/* Plug.c generated by valac 0.56.8, the Vala compiler
 * generated from Plug.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2014-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 */

#include "security-privacy.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <polkit/polkit.h>
#include <unistd.h>
#include <gmodule.h>

#define SECURITY_PRIVACY_PLUG_FIREWALL "firewall"
#define SECURITY_PRIVACY_PLUG_HOUSEKEEPING "housekeeping"
#define SECURITY_PRIVACY_PLUG_HISTORY "tracking"
#define SECURITY_PRIVACY_PLUG_LOCKING "locking"
#define SECURITY_PRIVACY_PLUG_LOCATION "location"

enum  {
	SECURITY_PRIVACY_PLUG_0_PROPERTY,
	SECURITY_PRIVACY_PLUG_NUM_PROPERTIES
};
static GParamSpec* security_privacy_plug_properties[SECURITY_PRIVACY_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SecurityPrivacyPlugSearchData SecurityPrivacyPlugSearchData;

struct _SecurityPrivacyPlugPrivate {
	GtkGrid* main_grid;
	GtkStack* stack;
	ServiceList* service_list;
};

struct _Block1Data {
	int _ref_count_;
	SecurityPrivacyPlug* self;
	GtkInfoBar* infobar;
};

struct _Block2Data {
	int _ref_count_;
	Block1Data * _data1_;
	PolkitPermission* permission;
};

struct _SecurityPrivacyPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SecurityPrivacyPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* map;
	GeeTreeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
};

GtkLockButton* security_privacy_lock_button = NULL;
SecurityPrivacyLocationPanel* security_privacy_location = NULL;
SecurityPrivacyFirewallPanel* security_privacy_firewall = NULL;
SecurityPrivacyHouseKeepingPanel* security_privacy_housekeeping = NULL;
SecurityPrivacyTrackPanel* security_privacy_tracking = NULL;
static gint SecurityPrivacyPlug_private_offset;
static gpointer security_privacy_plug_parent_class = NULL;

static GtkWidget* security_privacy_plug_real_get_widget (SwitchboardPlug* base);
static void security_privacy_plug_real_shown (SwitchboardPlug* base);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void ___lambda35_ (Block2Data* _data2_);
static void ____lambda35__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void ___lambda36_ (Block2Data* _data2_);
static void ____lambda36__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void __lambda37_ (SecurityPrivacyPlug* self,
                  GtkListBoxRow* row);
static void ___lambda37__gtk_list_box_row_selected (GtkListBox* _sender,
                                             GtkListBoxRow* row,
                                             gpointer self);
static void security_privacy_plug_real_hidden (SwitchboardPlug* base);
static void security_privacy_plug_real_search_callback (SwitchboardPlug* base,
                                                 const gchar* location);
static void security_privacy_plug_real_search_data_free (gpointer _data);
static void security_privacy_plug_real_search (SwitchboardPlug* base,
                                        const gchar* search,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gboolean security_privacy_plug_real_search_co (SecurityPrivacyPlugSearchData* _data_);
static void security_privacy_plug_finalize (GObject * obj);
static GType security_privacy_plug_get_type_once (void);

static inline gpointer
security_privacy_plug_get_instance_private (SecurityPrivacyPlug* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyPlug_private_offset);
}

SecurityPrivacyPlug*
security_privacy_plug_construct (GType object_type)
{
	SecurityPrivacyPlug * self = NULL;
	GeeTreeMap* _tmp0_;
	GeeTreeMap* _tmp1_;
	GeeTreeMap* _tmp2_;
	GeeTreeMap* _tmp3_;
	GeeTreeMap* _tmp4_;
	GeeTreeMap* _tmp5_;
	GeeTreeMap* _tmp6_;
	GeeTreeMap* _tmp7_;
	GeeTreeMap* _tmp8_;
	GeeTreeMap* _tmp9_;
	GeeTreeMap* _tmp10_;
	GeeTreeMap* _tmp11_;
	GeeTreeMap* _tmp12_;
	GeeTreeMap* _tmp13_;
	GeeTreeMap* _tmp14_;
	GeeTreeMap* _tmp15_;
	GeeTreeMap* _tmp16_;
	GeeTreeMap* _tmp17_;
	GeeTreeMap* _tmp18_;
	GeeTreeMap* _tmp19_;
	GeeTreeMap* _tmp20_;
	GeeTreeMap* _tmp21_;
	bindtextdomain (BUILD_GETTEXT_PACKAGE, BUILD_LOCALEDIR);
	bind_textdomain_codeset (BUILD_GETTEXT_PACKAGE, "UTF-8");
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	_tmp1_ = _tmp0_;
	self = (SecurityPrivacyPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_PERSONAL, "code-name", "io.elementary.switchboard.security-privacy", "display-name", _ ("Security & Privacy"), "description", _ ("Configure firewall, screen lock, and activity information"), "icon", "preferences-system-privacy", "supported-settings", _tmp1_, NULL);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
	_tmp3_ = _tmp2_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, "privacy", SECURITY_PRIVACY_PLUG_HISTORY);
	_tmp4_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
	_tmp5_ = _tmp4_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, "privacy/location", SECURITY_PRIVACY_PLUG_LOCATION);
	_tmp6_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
	_tmp7_ = _tmp6_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, "privacy/trash", SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
	_tmp8_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
	_tmp9_ = _tmp8_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, "security/firewall", SECURITY_PRIVACY_PLUG_FIREWALL);
	_tmp10_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
	_tmp11_ = _tmp10_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, "security/locking", SECURITY_PRIVACY_PLUG_LOCKING);
	_tmp12_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
	_tmp13_ = _tmp12_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, "security", NULL);
	_tmp14_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
	_tmp15_ = _tmp14_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, "security/housekeeping", SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
	_tmp16_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
	_tmp17_ = _tmp16_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, "security/privacy", SECURITY_PRIVACY_PLUG_HISTORY);
	_tmp18_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
	_tmp19_ = _tmp18_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, "security/privacy/location", SECURITY_PRIVACY_PLUG_LOCATION);
	_tmp20_ = switchboard_plug_get_supported_settings ((SwitchboardPlug*) self);
	_tmp21_ = _tmp20_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp21_, "security/screensaver", SECURITY_PRIVACY_PLUG_LOCKING);
	return self;
}

SecurityPrivacyPlug*
security_privacy_plug_new (void)
{
	return security_privacy_plug_construct (SECURITY_PRIVACY_TYPE_PLUG);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkWidget*
security_privacy_plug_real_get_widget (SwitchboardPlug* base)
{
	SecurityPrivacyPlug * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* result;
	self = (SecurityPrivacyPlug*) base;
	_tmp0_ = self->priv->main_grid;
	if (_tmp0_ == NULL) {
		GtkGrid* _tmp1_;
		_tmp1_ = (GtkGrid*) gtk_grid_new ();
		g_object_ref_sink (_tmp1_);
		_g_object_unref0 (self->priv->main_grid);
		self->priv->main_grid = _tmp1_;
	}
	_tmp2_ = self->priv->main_grid;
	_tmp3_ = _g_object_ref0 ((GtkWidget*) _tmp2_);
	result = _tmp3_;
	return result;
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		SecurityPrivacyPlug* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->infobar);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		SecurityPrivacyPlug* self;
		self = _data2_->_data1_->self;
		_g_object_unref0 (_data2_->permission);
		block1_data_unref (_data2_->_data1_);
		_data2_->_data1_ = NULL;
		g_slice_free (Block2Data, _data2_);
	}
}

static void
___lambda35_ (Block2Data* _data2_)
{
	Block1Data* _data1_;
	SecurityPrivacyPlug* self;
	gboolean _tmp0_ = FALSE;
	PolkitPermission* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	_data1_ = _data2_->_data1_;
	self = _data1_->self;
	_tmp1_ = _data2_->permission;
	_tmp2_ = g_permission_get_allowed ((GPermission*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == FALSE) {
		GtkStack* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp4_ = self->priv->stack;
		_tmp5_ = gtk_stack_get_visible_child_name (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = g_strcmp0 (_tmp6_, "firewall") == 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkInfoBar* _tmp7_;
		_tmp7_ = _data1_->infobar;
		gtk_info_bar_set_revealed (_tmp7_, TRUE);
	} else {
		GtkInfoBar* _tmp8_;
		_tmp8_ = _data1_->infobar;
		gtk_info_bar_set_revealed (_tmp8_, FALSE);
	}
}

static void
____lambda35__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	___lambda35_ (self);
}

static void
___lambda36_ (Block2Data* _data2_)
{
	Block1Data* _data1_;
	SecurityPrivacyPlug* self;
	gboolean _tmp0_ = FALSE;
	PolkitPermission* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	_data1_ = _data2_->_data1_;
	self = _data1_->self;
	_tmp1_ = _data2_->permission;
	_tmp2_ = g_permission_get_allowed ((GPermission*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == FALSE) {
		GtkStack* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp4_ = self->priv->stack;
		_tmp5_ = gtk_stack_get_visible_child_name (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = g_strcmp0 (_tmp6_, "firewall") == 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkInfoBar* _tmp7_;
		_tmp7_ = _data1_->infobar;
		gtk_info_bar_set_revealed (_tmp7_, TRUE);
	} else {
		GtkInfoBar* _tmp8_;
		_tmp8_ = _data1_->infobar;
		gtk_info_bar_set_revealed (_tmp8_, FALSE);
	}
}

static void
____lambda36__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	___lambda36_ (self);
}

static void
__lambda37_ (SecurityPrivacyPlug* self,
             GtkListBoxRow* row)
{
	gchar* title = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GtkStack* _tmp3_;
	_tmp0_ = service_item_get_title (G_TYPE_CHECK_INSTANCE_CAST (row, TYPE_SERVICE_ITEM, ServiceItem));
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	title = _tmp2_;
	_tmp3_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp3_, title);
	_g_free0 (title);
}

static void
___lambda37__gtk_list_box_row_selected (GtkListBox* _sender,
                                        GtkListBoxRow* row,
                                        gpointer self)
{
	__lambda37_ ((SecurityPrivacyPlug*) self, row);
}

static void
security_privacy_plug_real_shown (SwitchboardPlug* base)
{
	SecurityPrivacyPlug * self;
	Block1Data* _data1_;
	GtkGrid* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gboolean _tmp3_;
	GtkStack* _tmp4_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp5_;
	GtkInfoBar* _tmp6_ = NULL;
	GtkInfoBar* _tmp7_;
	GtkContainer* _tmp8_;
	GtkLabel* _tmp9_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp10_;
	GtkGrid* _tmp11_;
	GtkInfoBar* _tmp12_;
	GtkGrid* _tmp13_;
	GtkStack* _tmp14_;
	SecurityPrivacyTrackPanel* _tmp29_;
	SecurityPrivacyLockPanel* locking = NULL;
	SecurityPrivacyLockPanel* _tmp30_;
	SecurityPrivacyFirewallPanel* _tmp31_;
	SecurityPrivacyHouseKeepingPanel* _tmp32_;
	SecurityPrivacyLocationPanel* _tmp33_;
	GtkStack* _tmp34_;
	SecurityPrivacyTrackPanel* _tmp35_;
	GtkStack* _tmp36_;
	SecurityPrivacyLockPanel* _tmp37_;
	GtkStack* _tmp38_;
	SecurityPrivacyFirewallPanel* _tmp39_;
	GtkStack* _tmp40_;
	SecurityPrivacyHouseKeepingPanel* _tmp41_;
	GtkStack* _tmp42_;
	SecurityPrivacyLocationPanel* _tmp43_;
	ServiceList* _tmp44_;
	GtkPaned* paned = NULL;
	GtkPaned* _tmp45_;
	GtkPaned* _tmp46_;
	GtkPaned* _tmp47_;
	ServiceList* _tmp48_;
	GtkPaned* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkPaned* _tmp52_;
	GtkGrid* _tmp53_;
	ServiceList* _tmp54_;
	GError* _inner_error0_ = NULL;
	self = (SecurityPrivacyPlug*) base;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = self->priv->main_grid;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_list_length (_tmp2_) > ((guint) 0);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
	if (_tmp3_) {
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return;
	}
	_tmp4_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->stack);
	self->priv->stack = _tmp4_;
	_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Some settings require administrator rights to be changed"));
	g_object_ref_sink (_tmp5_);
	label = _tmp5_;
	_tmp6_ = (GtkInfoBar*) gtk_info_bar_new ();
	gtk_info_bar_set_message_type (_tmp6_, GTK_MESSAGE_INFO);
	g_object_ref_sink (_tmp6_);
	_data1_->infobar = _tmp6_;
	_tmp7_ = _data1_->infobar;
	_tmp8_ = gtk_info_bar_get_content_area (_tmp7_);
	_tmp9_ = label;
	gtk_container_add (_tmp8_, (GtkWidget*) _tmp9_);
	_tmp10_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp10_);
	grid = _tmp10_;
	_tmp11_ = grid;
	_tmp12_ = _data1_->infobar;
	gtk_grid_attach (_tmp11_, (GtkWidget*) _tmp12_, 0, 0, 1, 1);
	_tmp13_ = grid;
	_tmp14_ = self->priv->stack;
	gtk_grid_attach (_tmp13_, (GtkWidget*) _tmp14_, 0, 1, 1, 1);
	{
		Block2Data* _data2_;
		PolkitUnixProcess* _tmp15_;
		PolkitUnixProcess* _tmp16_;
		PolkitPermission* _tmp17_;
		PolkitPermission* _tmp18_;
		PolkitPermission* _tmp19_;
		GtkLockButton* _tmp20_;
		GtkInfoBar* _tmp21_;
		GtkInfoBar* _tmp22_;
		GtkBox* _tmp23_;
		GtkLockButton* _tmp24_;
		GtkStack* _tmp25_;
		PolkitPermission* _tmp26_;
		_data2_ = g_slice_new0 (Block2Data);
		_data2_->_ref_count_ = 1;
		_data2_->_data1_ = block1_data_ref (_data1_);
		_tmp15_ = (PolkitUnixProcess*) polkit_unix_process_new ((gint) getpid ());
		_tmp16_ = _tmp15_;
		_tmp17_ = (PolkitPermission*) polkit_permission_new_sync ("io.elementary.switchboard.security-privacy", (PolkitSubject*) _tmp16_, NULL, &_inner_error0_);
		_tmp18_ = _tmp17_;
		_g_object_unref0 (_tmp16_);
		_data2_->permission = _tmp18_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			block2_data_unref (_data2_);
			_data2_ = NULL;
			goto __catch0_g_error;
		}
		_tmp19_ = _data2_->permission;
		_tmp20_ = (GtkLockButton*) gtk_lock_button_new ((GPermission*) _tmp19_);
		g_object_ref_sink (_tmp20_);
		_g_object_unref0 (security_privacy_lock_button);
		security_privacy_lock_button = _tmp20_;
		_tmp21_ = _data1_->infobar;
		gtk_info_bar_set_revealed (_tmp21_, FALSE);
		_tmp22_ = _data1_->infobar;
		_tmp23_ = gtk_info_bar_get_action_area (_tmp22_);
		_tmp24_ = security_privacy_lock_button;
		gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
		_tmp25_ = self->priv->stack;
		g_signal_connect_data ((GObject*) _tmp25_, "notify::visible-child-name", (GCallback) ____lambda35__g_object_notify, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
		_tmp26_ = _data2_->permission;
		g_signal_connect_data ((GObject*) _tmp26_, "notify::allowed", (GCallback) ____lambda36__g_object_notify, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
		block2_data_unref (_data2_);
		_data2_ = NULL;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp27_ = e;
		_tmp28_ = _tmp27_->message;
		g_critical ("Plug.vala:120: %s", _tmp28_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (grid);
		_g_object_unref0 (label);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp29_ = security_privacy_track_panel_new ();
	g_object_ref_sink (_tmp29_);
	_g_object_unref0 (security_privacy_tracking);
	security_privacy_tracking = _tmp29_;
	_tmp30_ = security_privacy_lock_panel_new ();
	g_object_ref_sink (_tmp30_);
	locking = _tmp30_;
	_tmp31_ = security_privacy_firewall_panel_new ();
	g_object_ref_sink (_tmp31_);
	_g_object_unref0 (security_privacy_firewall);
	security_privacy_firewall = _tmp31_;
	_tmp32_ = security_privacy_house_keeping_panel_new ();
	g_object_ref_sink (_tmp32_);
	_g_object_unref0 (security_privacy_housekeeping);
	security_privacy_housekeeping = _tmp32_;
	_tmp33_ = security_privacy_location_panel_new ();
	g_object_ref_sink (_tmp33_);
	_g_object_unref0 (security_privacy_location);
	security_privacy_location = _tmp33_;
	_tmp34_ = self->priv->stack;
	_tmp35_ = security_privacy_tracking;
	gtk_stack_add_titled (_tmp34_, (GtkWidget*) _tmp35_, SECURITY_PRIVACY_PLUG_HISTORY, _ ("Privacy"));
	_tmp36_ = self->priv->stack;
	_tmp37_ = locking;
	gtk_stack_add_titled (_tmp36_, (GtkWidget*) _tmp37_, SECURITY_PRIVACY_PLUG_LOCKING, _ ("Locking"));
	_tmp38_ = self->priv->stack;
	_tmp39_ = security_privacy_firewall;
	gtk_stack_add_titled (_tmp38_, (GtkWidget*) _tmp39_, SECURITY_PRIVACY_PLUG_FIREWALL, _ ("Firewall"));
	_tmp40_ = self->priv->stack;
	_tmp41_ = security_privacy_housekeeping;
	gtk_stack_add_titled (_tmp40_, (GtkWidget*) _tmp41_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING, _ ("Housekeeping"));
	_tmp42_ = self->priv->stack;
	_tmp43_ = security_privacy_location;
	gtk_stack_add_titled (_tmp42_, (GtkWidget*) _tmp43_, SECURITY_PRIVACY_PLUG_LOCATION, _ ("Location Services"));
	_tmp44_ = service_list_new ();
	g_object_ref_sink (_tmp44_);
	_g_object_unref0 (self->priv->service_list);
	self->priv->service_list = _tmp44_;
	_tmp45_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp45_);
	paned = _tmp45_;
	_tmp46_ = paned;
	gtk_paned_set_position (_tmp46_, 200);
	_tmp47_ = paned;
	_tmp48_ = self->priv->service_list;
	gtk_paned_add1 (_tmp47_, (GtkWidget*) _tmp48_);
	_tmp49_ = paned;
	_tmp50_ = grid;
	gtk_paned_add2 (_tmp49_, (GtkWidget*) _tmp50_);
	_tmp51_ = self->priv->main_grid;
	_tmp52_ = paned;
	gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
	_tmp53_ = self->priv->main_grid;
	gtk_widget_show_all ((GtkWidget*) _tmp53_);
	_tmp54_ = self->priv->service_list;
	g_signal_connect_object ((GtkListBox*) _tmp54_, "row-selected", (GCallback) ___lambda37__gtk_list_box_row_selected, self, 0);
	_g_object_unref0 (paned);
	_g_object_unref0 (locking);
	_g_object_unref0 (grid);
	_g_object_unref0 (label);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static void
security_privacy_plug_real_hidden (SwitchboardPlug* base)
{
	SecurityPrivacyPlug * self;
	self = (SecurityPrivacyPlug*) base;
}

static void
security_privacy_plug_real_search_callback (SwitchboardPlug* base,
                                            const gchar* location)
{
	SecurityPrivacyPlug * self;
	GtkGrid* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gboolean _tmp3_;
	GtkStack* _tmp4_;
	ServiceList* _tmp5_;
	self = (SecurityPrivacyPlug*) base;
	g_return_if_fail (location != NULL);
	_tmp0_ = self->priv->main_grid;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_list_length (_tmp2_) == ((guint) 0);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
	if (_tmp3_) {
		switchboard_plug_shown ((SwitchboardPlug*) self);
	}
	_tmp4_ = self->priv->stack;
	gtk_stack_set_visible_child_name (_tmp4_, location);
	_tmp5_ = self->priv->service_list;
	service_list_select_service_name (_tmp5_, location);
}

static void
security_privacy_plug_real_search_data_free (gpointer _data)
{
	SecurityPrivacyPlugSearchData* _data_;
	_data_ = _data;
	_g_free0 (_data_->search);
	_g_object_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (SecurityPrivacyPlugSearchData, _data_);
}

static void
security_privacy_plug_real_search (SwitchboardPlug* base,
                                   const gchar* search,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	SecurityPrivacyPlug * self;
	SecurityPrivacyPlugSearchData* _data_;
	SecurityPrivacyPlug* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (search != NULL);
	self = (SecurityPrivacyPlug*) base;
	_data_ = g_slice_new0 (SecurityPrivacyPlugSearchData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, security_privacy_plug_real_search_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (search);
	_g_free0 (_data_->search);
	_data_->search = _tmp1_;
	security_privacy_plug_real_search_co (_data_);
}

static GeeTreeMap*
security_privacy_plug_search_finish (SwitchboardPlug* base,
                                     GAsyncResult* _res_)
{
	GeeTreeMap* result;
	SecurityPrivacyPlugSearchData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static gboolean
security_privacy_plug_real_search_co (SecurityPrivacyPlugSearchData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	_data_->map = _data_->_tmp0_;
	_data_->_tmp1_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = g_strdup_printf ("%s → %s", _data_->_tmp2_, _ ("History"));
	_data_->_tmp4_ = _data_->_tmp3_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp4_, SECURITY_PRIVACY_PLUG_HISTORY);
	_g_free0 (_data_->_tmp4_);
	_data_->_tmp5_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp6_ = _data_->_tmp5_;
	_data_->_tmp7_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp6_, _ ("History"), _ ("Clear History"));
	_data_->_tmp8_ = _data_->_tmp7_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp8_, SECURITY_PRIVACY_PLUG_HISTORY);
	_g_free0 (_data_->_tmp8_);
	_data_->_tmp9_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp10_ = _data_->_tmp9_;
	_data_->_tmp11_ = g_strdup_printf ("%s → %s", _data_->_tmp10_, _ ("Locking"));
	_data_->_tmp12_ = _data_->_tmp11_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp12_, SECURITY_PRIVACY_PLUG_LOCKING);
	_g_free0 (_data_->_tmp12_);
	_data_->_tmp13_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp14_ = _data_->_tmp13_;
	_data_->_tmp15_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp14_, _ ("Locking"), _ ("Lock on sleep"));
	_data_->_tmp16_ = _data_->_tmp15_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp16_, SECURITY_PRIVACY_PLUG_HISTORY);
	_g_free0 (_data_->_tmp16_);
	_data_->_tmp17_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp18_ = _data_->_tmp17_;
	_data_->_tmp19_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp18_, _ ("Locking"), _ ("Lock after sceen turns off"));
	_data_->_tmp20_ = _data_->_tmp19_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp20_, SECURITY_PRIVACY_PLUG_HISTORY);
	_g_free0 (_data_->_tmp20_);
	_data_->_tmp21_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp22_ = _data_->_tmp21_;
	_data_->_tmp23_ = g_strdup_printf ("%s → %s", _data_->_tmp22_, _ ("Firewall"));
	_data_->_tmp24_ = _data_->_tmp23_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp24_, SECURITY_PRIVACY_PLUG_FIREWALL);
	_g_free0 (_data_->_tmp24_);
	_data_->_tmp25_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp26_ = _data_->_tmp25_;
	_data_->_tmp27_ = g_strdup_printf ("%s → %s", _data_->_tmp26_, _ ("Housekeeping"));
	_data_->_tmp28_ = _data_->_tmp27_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp28_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
	_g_free0 (_data_->_tmp28_);
	_data_->_tmp29_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp30_ = _data_->_tmp29_;
	_data_->_tmp31_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp30_, _ ("Housekeeping"), _ ("Automatically delete old temporary files"));
	_data_->_tmp32_ = _data_->_tmp31_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp32_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
	_g_free0 (_data_->_tmp32_);
	_data_->_tmp33_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp34_ = _data_->_tmp33_;
	_data_->_tmp35_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp34_, _ ("Housekeeping"), _ ("Automatically delete old screenshot files"));
	_data_->_tmp36_ = _data_->_tmp35_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp36_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
	_g_free0 (_data_->_tmp36_);
	_data_->_tmp37_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp38_ = _data_->_tmp37_;
	_data_->_tmp39_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp38_, _ ("Housekeeping"), _ ("Automatically delete old trashed files"));
	_data_->_tmp40_ = _data_->_tmp39_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp40_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
	_g_free0 (_data_->_tmp40_);
	_data_->_tmp41_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp42_ = _data_->_tmp41_;
	_data_->_tmp43_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp42_, _ ("Housekeeping"), _ ("Number of days to keep trashed and temporary files"));
	_data_->_tmp44_ = _data_->_tmp43_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp44_, SECURITY_PRIVACY_PLUG_HOUSEKEEPING);
	_g_free0 (_data_->_tmp44_);
	_data_->_tmp45_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
	_data_->_tmp46_ = _data_->_tmp45_;
	_data_->_tmp47_ = g_strdup_printf ("%s → %s", _data_->_tmp46_, _ ("Location Services"));
	_data_->_tmp48_ = _data_->_tmp47_;
	gee_abstract_map_set ((GeeAbstractMap*) _data_->map, _data_->_tmp48_, SECURITY_PRIVACY_PLUG_LOCATION);
	_g_free0 (_data_->_tmp48_);
	_data_->result = _data_->map;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
security_privacy_plug_class_init (SecurityPrivacyPlugClass * klass,
                                  gpointer klass_data)
{
	security_privacy_plug_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyPlug_private_offset);
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) security_privacy_plug_real_get_widget;
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) security_privacy_plug_real_shown;
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) security_privacy_plug_real_hidden;
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) security_privacy_plug_real_search_callback;
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) security_privacy_plug_real_search;
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) security_privacy_plug_search_finish;
	G_OBJECT_CLASS (klass)->finalize = security_privacy_plug_finalize;
}

static void
security_privacy_plug_instance_init (SecurityPrivacyPlug * self,
                                     gpointer klass)
{
	self->priv = security_privacy_plug_get_instance_private (self);
}

static void
security_privacy_plug_finalize (GObject * obj)
{
	SecurityPrivacyPlug * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_PLUG, SecurityPrivacyPlug);
	_g_object_unref0 (self->priv->main_grid);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->service_list);
	G_OBJECT_CLASS (security_privacy_plug_parent_class)->finalize (obj);
}

static GType
security_privacy_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyPlug), 0, (GInstanceInitFunc) security_privacy_plug_instance_init, NULL };
	GType security_privacy_plug_type_id;
	security_privacy_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "SecurityPrivacyPlug", &g_define_type_info, 0);
	SecurityPrivacyPlug_private_offset = g_type_add_instance_private (security_privacy_plug_type_id, sizeof (SecurityPrivacyPlugPrivate));
	return security_privacy_plug_type_id;
}

GType
security_privacy_plug_get_type (void)
{
	static volatile gsize security_privacy_plug_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_plug_type_id__once)) {
		GType security_privacy_plug_type_id;
		security_privacy_plug_type_id = security_privacy_plug_get_type_once ();
		g_once_init_leave (&security_privacy_plug_type_id__once, security_privacy_plug_type_id);
	}
	return security_privacy_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	SecurityPrivacyPlug* plug = NULL;
	SecurityPrivacyPlug* _tmp0_;
	SwitchboardPlug* result;
	g_return_val_if_fail (module != NULL, NULL);
	g_debug ("Plug.vala:201: Activating Security & Privacy plug");
	_tmp0_ = security_privacy_plug_new ();
	plug = _tmp0_;
	result = (SwitchboardPlug*) plug;
	return result;
}

