/* FirewallPanel.c generated by valac 0.56.8, the Vala compiler
 * generated from FirewallPanel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2014-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 */

#include "security-privacy.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <granite.h>

enum  {
	SECURITY_PRIVACY_FIREWALL_PANEL_0_PROPERTY,
	SECURITY_PRIVACY_FIREWALL_PANEL_NUM_PROPERTIES
};
static GParamSpec* security_privacy_firewall_panel_properties[SECURITY_PRIVACY_FIREWALL_PANEL_NUM_PROPERTIES];
typedef enum  {
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE,
	SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS
} SecurityPrivacyFirewallPanelColumns;

#define SECURITY_PRIVACY_FIREWALL_PANEL_TYPE_COLUMNS (security_privacy_firewall_panel_columns_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef struct _Block5Data Block5Data;

struct _SecurityPrivacyFirewallPanelPrivate {
	GtkListStore* list_store;
	GtkTreeView* view;
	GtkActionBar* actionbar;
	gboolean loading;
	GtkPopover* add_popover;
	GtkButton* remove_button;
	GSettings* settings;
	GeeHashMap* disabled_rules;
};

struct _Block3Data {
	int _ref_count_;
	SecurityPrivacyFirewallPanel* self;
	SecurityPrivacyUFWHelpersRule* rule;
	gchar* ufw_hash;
};

struct _Block4Data {
	int _ref_count_;
	SecurityPrivacyFirewallPanel* self;
	GtkButton* add_button;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	GtkComboBoxText* policy_combobox;
	GtkComboBoxText* protocol_combobox;
	GtkComboBoxText* version_combobox;
	GtkComboBoxText* direction_combobox;
	GtkEntry* ports_entry;
};

static gint SecurityPrivacyFirewallPanel_private_offset;
static gpointer security_privacy_firewall_panel_parent_class = NULL;

static GType security_privacy_firewall_panel_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void security_privacy_firewall_panel_load_disabled_rules (SecurityPrivacyFirewallPanel* self);
static gchar* security_privacy_firewall_panel_generate_hash_for_rule (SecurityPrivacyFirewallPanel* self,
                                                               SecurityPrivacyUFWHelpersRule* r);
static void security_privacy_firewall_panel_reload_rule_numbers (SecurityPrivacyFirewallPanel* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean ____lambda9_ (Block3Data* _data3_,
                       GtkTreeModel* model,
                       GtkTreePath* path,
                       GtkTreeIter* iter);
static gboolean _____lambda9__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                    GtkTreePath* path,
                                                    GtkTreeIter* iter,
                                                    gpointer self);
static void security_privacy_firewall_panel_show_rules (SecurityPrivacyFirewallPanel* self);
static void security_privacy_firewall_panel_disable_rule (SecurityPrivacyFirewallPanel* self,
                                                   SecurityPrivacyUFWHelpersRule* rule);
static void security_privacy_firewall_panel_save_disabled_rules (SecurityPrivacyFirewallPanel* self,
                                                          SecurityPrivacyUFWHelpersRule* additional_rule);
static void security_privacy_firewall_panel_enable_rule (SecurityPrivacyFirewallPanel* self,
                                                  const gchar* hash);
static void security_privacy_firewall_panel_delete_disabled_rule (SecurityPrivacyFirewallPanel* self,
                                                           const gchar* hash);
static void security_privacy_firewall_panel_create_treeview (SecurityPrivacyFirewallPanel* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda10_ (SecurityPrivacyFirewallPanel* self,
                  const gchar* path);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void ___lambda10__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                                    const gchar* path,
                                                    gpointer self);
static void __lambda11_ (Block4Data* _data4_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda12_ (Block5Data* _data5_);
static void ___lambda12__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void ___lambda11__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda13_ (SecurityPrivacyFirewallPanel* self);
static void ___lambda13__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda14_ (SecurityPrivacyFirewallPanel* self);
static void ___lambda14__gtk_tree_view_cursor_changed (GtkTreeView* _sender,
                                                gpointer self);
static GObject * security_privacy_firewall_panel_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static void _security_privacy_firewall_panel___lambda15_ (SecurityPrivacyFirewallPanel* self);
static void __security_privacy_firewall_panel___lambda15__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void _security_privacy_firewall_panel___lambda16_ (SecurityPrivacyFirewallPanel* self);
static void __security_privacy_firewall_panel___lambda16__g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
static void security_privacy_firewall_panel_finalize (GObject * obj);
static GType security_privacy_firewall_panel_get_type_once (void);

static inline gpointer
security_privacy_firewall_panel_get_instance_private (SecurityPrivacyFirewallPanel* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyFirewallPanel_private_offset);
}

static GType
security_privacy_firewall_panel_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION", "action"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL", "protocol"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION", "direction"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO", "to"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM", "from"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6", "v6"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED", "enabled"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE", "rule"}, {SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS, "SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
	GType security_privacy_firewall_panel_columns_type_id;
	security_privacy_firewall_panel_columns_type_id = g_enum_register_static ("SecurityPrivacyFirewallPanelColumns", values);
	return security_privacy_firewall_panel_columns_type_id;
}

static GType
security_privacy_firewall_panel_columns_get_type (void)
{
	static volatile gsize security_privacy_firewall_panel_columns_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_firewall_panel_columns_type_id__once)) {
		GType security_privacy_firewall_panel_columns_type_id;
		security_privacy_firewall_panel_columns_type_id = security_privacy_firewall_panel_columns_get_type_once ();
		g_once_init_leave (&security_privacy_firewall_panel_columns_type_id__once, security_privacy_firewall_panel_columns_type_id);
	}
	return security_privacy_firewall_panel_columns_type_id__once;
}

SecurityPrivacyFirewallPanel*
security_privacy_firewall_panel_construct (GType object_type)
{
	SecurityPrivacyFirewallPanel * self = NULL;
	self = (SecurityPrivacyFirewallPanel*) g_object_new (object_type, "activatable", TRUE, "icon-name", "network-firewall", "title", _ ("Firewall"), NULL);
	return self;
}

SecurityPrivacyFirewallPanel*
security_privacy_firewall_panel_new (void)
{
	return security_privacy_firewall_panel_construct (SECURITY_PRIVACY_TYPE_FIREWALL_PANEL);
}

static void
security_privacy_firewall_panel_load_disabled_rules (SecurityPrivacyFirewallPanel* self)
{
	GeeHashMap* _tmp0_;
	gchar* to = NULL;
	gchar* _tmp1_;
	gchar* to_ports = NULL;
	gchar* _tmp2_;
	gchar* from = NULL;
	gchar* _tmp3_;
	gchar* from_ports = NULL;
	gchar* _tmp4_;
	gint action = 0;
	gint protocol = 0;
	gint direction = 0;
	gint version = 0;
	GVariant* rules = NULL;
	GSettings* _tmp5_;
	GVariant* _tmp6_;
	GVariantIter* iter = NULL;
	GVariant* _tmp7_;
	GVariantIter* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->disabled_rules);
	self->priv->disabled_rules = _tmp0_;
	_tmp1_ = g_strdup ("");
	to = _tmp1_;
	_tmp2_ = g_strdup ("");
	to_ports = _tmp2_;
	_tmp3_ = g_strdup ("");
	from = _tmp3_;
	_tmp4_ = g_strdup ("");
	from_ports = _tmp4_;
	action = 0;
	protocol = 0;
	direction = 0;
	version = 0;
	_tmp5_ = self->priv->settings;
	_tmp6_ = g_settings_get_value (_tmp5_, "disabled-firewall-rules");
	rules = _tmp6_;
	_tmp7_ = rules;
	_tmp8_ = g_variant_iter_new (_tmp7_);
	iter = _tmp8_;
	while (TRUE) {
		GVariantIter* _tmp9_;
		gboolean _tmp10_;
		SecurityPrivacyUFWHelpersRule* new_rule = NULL;
		SecurityPrivacyUFWHelpersRule* _tmp11_;
		SecurityPrivacyUFWHelpersRule* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		SecurityPrivacyUFWHelpersRule* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		SecurityPrivacyUFWHelpersRule* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		SecurityPrivacyUFWHelpersRule* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		SecurityPrivacyUFWHelpersRule* _tmp24_;
		SecurityPrivacyUFWHelpersRule* _tmp25_;
		SecurityPrivacyUFWHelpersRule* _tmp26_;
		SecurityPrivacyUFWHelpersRule* _tmp27_;
		gchar* hash = NULL;
		SecurityPrivacyUFWHelpersRule* _tmp28_;
		gchar* _tmp29_;
		GeeHashMap* _tmp30_;
		const gchar* _tmp31_;
		SecurityPrivacyUFWHelpersRule* _tmp32_;
		_tmp9_ = iter;
		_tmp10_ = g_variant_iter_next (_tmp9_, "(ssssiiii)", &to, &to_ports, &from, &from_ports, &action, &protocol, &direction, &version, NULL);
		if (!_tmp10_) {
			break;
		}
		_tmp11_ = security_privacy_ufw_helpers_rule_new ();
		new_rule = _tmp11_;
		_tmp12_ = new_rule;
		_tmp13_ = to;
		_tmp14_ = g_strdup (_tmp13_);
		_g_free0 (_tmp12_->to);
		_tmp12_->to = _tmp14_;
		_tmp15_ = new_rule;
		_tmp16_ = to_ports;
		_tmp17_ = g_strdup (_tmp16_);
		_g_free0 (_tmp15_->to_ports);
		_tmp15_->to_ports = _tmp17_;
		_tmp18_ = new_rule;
		_tmp19_ = from;
		_tmp20_ = g_strdup (_tmp19_);
		_g_free0 (_tmp18_->from);
		_tmp18_->from = _tmp20_;
		_tmp21_ = new_rule;
		_tmp22_ = from_ports;
		_tmp23_ = g_strdup (_tmp22_);
		_g_free0 (_tmp21_->from_ports);
		_tmp21_->from_ports = _tmp23_;
		_tmp24_ = new_rule;
		_tmp24_->action = (SecurityPrivacyUFWHelpersRuleAction) action;
		_tmp25_ = new_rule;
		_tmp25_->protocol = (SecurityPrivacyUFWHelpersRuleProtocol) protocol;
		_tmp26_ = new_rule;
		_tmp26_->direction = (SecurityPrivacyUFWHelpersRuleDirection) direction;
		_tmp27_ = new_rule;
		_tmp27_->version = (SecurityPrivacyUFWHelpersRuleVersion) version;
		_tmp28_ = new_rule;
		_tmp29_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp28_);
		hash = _tmp29_;
		_tmp30_ = self->priv->disabled_rules;
		_tmp31_ = hash;
		_tmp32_ = new_rule;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp30_, _tmp31_, _tmp32_);
		_g_free0 (hash);
		_g_object_unref0 (new_rule);
	}
	_g_variant_iter_free0 (iter);
	_g_variant_unref0 (rules);
	_g_free0 (from_ports);
	_g_free0 (from);
	_g_free0 (to_ports);
	_g_free0 (to);
}

static gchar*
security_privacy_firewall_panel_generate_hash_for_rule (SecurityPrivacyFirewallPanel* self,
                                                        SecurityPrivacyUFWHelpersRule* r)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GEnumValue* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GEnumValue* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GEnumValue* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GEnumValue* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (r != NULL, NULL);
	_tmp0_ = r->to;
	_tmp1_ = r->to_ports;
	_tmp2_ = g_strconcat (_tmp0_, _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = r->from;
	_tmp5_ = g_strconcat (_tmp3_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = r->from_ports;
	_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_ACTION), r->action);
	_tmp11_ = g_strconcat (_tmp9_, (_tmp10_ != NULL) ? _tmp10_->value_name : NULL, NULL);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_PROTOCOL), r->protocol);
	_tmp14_ = g_strconcat (_tmp12_, (_tmp13_ != NULL) ? _tmp13_->value_name : NULL, NULL);
	_tmp15_ = _tmp14_;
	_tmp16_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_DIRECTION), r->direction);
	_tmp17_ = g_strconcat (_tmp15_, (_tmp16_ != NULL) ? _tmp16_->value_name : NULL, NULL);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_enum_get_value (g_type_class_ref (SECURITY_PRIVACY_UFW_HELPERS_RULE_TYPE_VERSION), r->version);
	_tmp20_ = g_strconcat (_tmp18_, (_tmp19_ != NULL) ? _tmp19_->value_name : NULL, NULL);
	_tmp21_ = _tmp20_;
	_g_free0 (_tmp18_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp3_);
	result = _tmp21_;
	return result;
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		SecurityPrivacyFirewallPanel* self;
		self = _data3_->self;
		_g_free0 (_data3_->ufw_hash);
		_g_object_unref0 (_data3_->rule);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
____lambda9_ (Block3Data* _data3_,
              GtkTreeModel* model,
              GtkTreePath* path,
              GtkTreeIter* iter)
{
	SecurityPrivacyFirewallPanel* self;
	GValue val = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GValue _tmp2_ = {0};
	SecurityPrivacyUFWHelpersRule* tree_rule = NULL;
	GValue _tmp3_;
	SecurityPrivacyUFWHelpersRule* _tmp4_;
	gchar* tree_hash = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gboolean result;
	self = _data3_->self;
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->list_store;
	_tmp1_ = *iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp0_, &_tmp1_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp2_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp2_;
	_tmp3_ = val;
	_tmp4_ = _g_object_ref0 (g_value_get_object (&_tmp3_));
	tree_rule = _tmp4_;
	_tmp5_ = tree_rule;
	_tmp6_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp5_);
	tree_hash = _tmp6_;
	_tmp7_ = _data3_->ufw_hash;
	_tmp8_ = tree_hash;
	if (g_strcmp0 (_tmp7_, _tmp8_) == 0) {
		SecurityPrivacyUFWHelpersRule* _tmp9_;
		SecurityPrivacyUFWHelpersRule* _tmp10_;
		GtkListStore* _tmp11_;
		GtkTreeIter _tmp12_;
		SecurityPrivacyUFWHelpersRule* _tmp13_;
		GValue _tmp14_ = {0};
		_tmp9_ = tree_rule;
		_tmp10_ = _data3_->rule;
		_tmp9_->number = _tmp10_->number;
		_tmp11_ = self->priv->list_store;
		_tmp12_ = *iter;
		_tmp13_ = tree_rule;
		g_value_init (&_tmp14_, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE);
		g_value_set_object (&_tmp14_, _tmp13_);
		gtk_list_store_set_value (_tmp11_, &_tmp12_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp14_);
		G_IS_VALUE (&_tmp14_) ? (g_value_unset (&_tmp14_), NULL) : NULL;
		result = TRUE;
		_g_free0 (tree_hash);
		_g_object_unref0 (tree_rule);
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		return result;
	}
	result = FALSE;
	_g_free0 (tree_hash);
	_g_object_unref0 (tree_rule);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return result;
}

static gboolean
_____lambda9__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                           GtkTreePath* path,
                                           GtkTreeIter* iter,
                                           gpointer self)
{
	gboolean result;
	result = ____lambda9_ (self, model, path, iter);
	return result;
}

static void
security_privacy_firewall_panel_reload_rule_numbers (SecurityPrivacyFirewallPanel* self)
{
	g_return_if_fail (self != NULL);
	{
		GeeLinkedList* _rule_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _rule_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _rule_index = 0;
		_tmp0_ = security_privacy_ufw_helpers_get_rules ();
		_rule_list = _tmp0_;
		_tmp1_ = _rule_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_rule_size = _tmp3_;
		_rule_index = -1;
		while (TRUE) {
			Block3Data* _data3_;
			gint _tmp4_;
			gint _tmp5_;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			SecurityPrivacyUFWHelpersRule* _tmp8_;
			gchar* _tmp9_;
			GtkTreeModelForeachFunc update_row = NULL;
			gpointer update_row_target;
			GDestroyNotify update_row_target_destroy_notify;
			GtkListStore* _tmp10_;
			GtkTreeModelForeachFunc _tmp11_;
			gpointer _tmp11__target;
			_data3_ = g_slice_new0 (Block3Data);
			_data3_->_ref_count_ = 1;
			_data3_->self = g_object_ref (self);
			_rule_index = _rule_index + 1;
			_tmp4_ = _rule_index;
			_tmp5_ = _rule_size;
			if (!(_tmp4_ < _tmp5_)) {
				block3_data_unref (_data3_);
				_data3_ = NULL;
				break;
			}
			_tmp6_ = _rule_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _rule_index);
			_data3_->rule = (SecurityPrivacyUFWHelpersRule*) _tmp7_;
			_tmp8_ = _data3_->rule;
			_tmp9_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp8_);
			_data3_->ufw_hash = _tmp9_;
			update_row = _____lambda9__gtk_tree_model_foreach_func;
			update_row_target = block3_data_ref (_data3_);
			update_row_target_destroy_notify = block3_data_unref;
			_tmp10_ = self->priv->list_store;
			_tmp11_ = update_row;
			_tmp11__target = update_row_target;
			gtk_tree_model_foreach ((GtkTreeModel*) _tmp10_, _tmp11_, _tmp11__target);
			(update_row_target_destroy_notify == NULL) ? NULL : (update_row_target_destroy_notify (update_row_target), NULL);
			update_row = NULL;
			update_row_target = NULL;
			update_row_target_destroy_notify = NULL;
			block3_data_unref (_data3_);
			_data3_ = NULL;
		}
		_g_object_unref0 (_rule_list);
	}
}

static void
security_privacy_firewall_panel_show_rules (SecurityPrivacyFirewallPanel* self)
{
	GtkListStore* _tmp0_;
	GtkButton* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->list_store;
	gtk_list_store_clear (_tmp0_);
	_tmp1_ = self->priv->remove_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
	{
		GeeLinkedList* _rule_list = NULL;
		GeeLinkedList* _tmp2_;
		gint _rule_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _rule_index = 0;
		_tmp2_ = security_privacy_ufw_helpers_get_rules ();
		_rule_list = _tmp2_;
		_tmp3_ = _rule_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_rule_size = _tmp5_;
		_rule_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			SecurityPrivacyUFWHelpersRule* rule = NULL;
			GeeLinkedList* _tmp8_;
			gpointer _tmp9_;
			SecurityPrivacyUFWHelpersRule* _tmp10_;
			_rule_index = _rule_index + 1;
			_tmp6_ = _rule_index;
			_tmp7_ = _rule_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _rule_list;
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _rule_index);
			rule = (SecurityPrivacyUFWHelpersRule*) _tmp9_;
			_tmp10_ = rule;
			security_privacy_firewall_panel_add_rule (self, _tmp10_, TRUE, "");
			_g_object_unref0 (rule);
		}
		_g_object_unref0 (_rule_list);
	}
	security_privacy_firewall_panel_load_disabled_rules (self);
	{
		GeeIterator* _rule_it = NULL;
		GeeHashMap* _tmp11_;
		GeeSet* _tmp12_;
		GeeSet* _tmp13_;
		GeeSet* _tmp14_;
		GeeIterator* _tmp15_;
		GeeIterator* _tmp16_;
		_tmp11_ = self->priv->disabled_rules;
		_tmp12_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = _tmp13_;
		_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
		_tmp16_ = _tmp15_;
		_g_object_unref0 (_tmp14_);
		_rule_it = _tmp16_;
		while (TRUE) {
			GeeIterator* _tmp17_;
			GeeMapEntry* rule = NULL;
			GeeIterator* _tmp18_;
			gpointer _tmp19_;
			GeeMapEntry* _tmp20_;
			gconstpointer _tmp21_;
			gconstpointer _tmp22_;
			GeeMapEntry* _tmp23_;
			gconstpointer _tmp24_;
			gconstpointer _tmp25_;
			_tmp17_ = _rule_it;
			if (!gee_iterator_next (_tmp17_)) {
				break;
			}
			_tmp18_ = _rule_it;
			_tmp19_ = gee_iterator_get (_tmp18_);
			rule = (GeeMapEntry*) _tmp19_;
			_tmp20_ = rule;
			_tmp21_ = gee_map_entry_get_value (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp23_ = rule;
			_tmp24_ = gee_map_entry_get_key (_tmp23_);
			_tmp25_ = _tmp24_;
			security_privacy_firewall_panel_add_rule (self, (SecurityPrivacyUFWHelpersRule*) _tmp22_, FALSE, (const gchar*) _tmp25_);
			_g_object_unref0 (rule);
		}
		_g_object_unref0 (_rule_it);
	}
}

static void
security_privacy_firewall_panel_disable_rule (SecurityPrivacyFirewallPanel* self,
                                              SecurityPrivacyUFWHelpersRule* rule)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (rule != NULL);
	security_privacy_firewall_panel_save_disabled_rules (self, rule);
	security_privacy_ufw_helpers_remove_rule (rule);
}

static void
security_privacy_firewall_panel_enable_rule (SecurityPrivacyFirewallPanel* self,
                                             const gchar* hash)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	SecurityPrivacyUFWHelpersRule* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (hash != NULL);
	_tmp0_ = self->priv->disabled_rules;
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, hash);
	_tmp2_ = (SecurityPrivacyUFWHelpersRule*) _tmp1_;
	security_privacy_ufw_helpers_add_rule (_tmp2_);
	_g_object_unref0 (_tmp2_);
	security_privacy_firewall_panel_delete_disabled_rule (self, hash);
}

static void
security_privacy_firewall_panel_delete_disabled_rule (SecurityPrivacyFirewallPanel* self,
                                                      const gchar* hash)
{
	GeeHashMap* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (hash != NULL);
	_tmp0_ = self->priv->disabled_rules;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, hash, NULL);
	security_privacy_firewall_panel_save_disabled_rules (self, NULL);
}

static void
security_privacy_firewall_panel_save_disabled_rules (SecurityPrivacyFirewallPanel* self,
                                                     SecurityPrivacyUFWHelpersRule* additional_rule)
{
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	GSettings* _tmp31_;
	GVariantBuilder* _tmp32_;
	GVariant* _tmp33_;
	GVariant* _tmp34_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_variant_type_new ("a(ssssiiii)");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_builder_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	builder = _tmp3_;
	{
		GeeIterator* _existing_rule_it = NULL;
		GeeHashMap* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		GeeIterator* _tmp8_;
		GeeIterator* _tmp9_;
		_tmp4_ = self->priv->disabled_rules;
		_tmp5_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = _tmp6_;
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
		_tmp9_ = _tmp8_;
		_g_object_unref0 (_tmp7_);
		_existing_rule_it = _tmp9_;
		while (TRUE) {
			GeeIterator* _tmp10_;
			SecurityPrivacyUFWHelpersRule* existing_rule = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			GVariantBuilder* _tmp13_;
			SecurityPrivacyUFWHelpersRule* _tmp14_;
			const gchar* _tmp15_;
			SecurityPrivacyUFWHelpersRule* _tmp16_;
			const gchar* _tmp17_;
			SecurityPrivacyUFWHelpersRule* _tmp18_;
			const gchar* _tmp19_;
			SecurityPrivacyUFWHelpersRule* _tmp20_;
			const gchar* _tmp21_;
			SecurityPrivacyUFWHelpersRule* _tmp22_;
			SecurityPrivacyUFWHelpersRule* _tmp23_;
			SecurityPrivacyUFWHelpersRule* _tmp24_;
			SecurityPrivacyUFWHelpersRule* _tmp25_;
			_tmp10_ = _existing_rule_it;
			if (!gee_iterator_next (_tmp10_)) {
				break;
			}
			_tmp11_ = _existing_rule_it;
			_tmp12_ = gee_iterator_get (_tmp11_);
			existing_rule = (SecurityPrivacyUFWHelpersRule*) _tmp12_;
			_tmp13_ = builder;
			_tmp14_ = existing_rule;
			_tmp15_ = _tmp14_->to;
			_tmp16_ = existing_rule;
			_tmp17_ = _tmp16_->to_ports;
			_tmp18_ = existing_rule;
			_tmp19_ = _tmp18_->from;
			_tmp20_ = existing_rule;
			_tmp21_ = _tmp20_->from_ports;
			_tmp22_ = existing_rule;
			_tmp23_ = existing_rule;
			_tmp24_ = existing_rule;
			_tmp25_ = existing_rule;
			g_variant_builder_add (_tmp13_, "(ssssiiii)", _tmp15_, _tmp17_, _tmp19_, _tmp21_, _tmp22_->action, _tmp23_->protocol, _tmp24_->direction, _tmp25_->version, NULL);
			_g_object_unref0 (existing_rule);
		}
		_g_object_unref0 (_existing_rule_it);
	}
	if (additional_rule != NULL) {
		GVariantBuilder* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		_tmp26_ = builder;
		_tmp27_ = additional_rule->to;
		_tmp28_ = additional_rule->to_ports;
		_tmp29_ = additional_rule->from;
		_tmp30_ = additional_rule->from_ports;
		g_variant_builder_add (_tmp26_, "(ssssiiii)", _tmp27_, _tmp28_, _tmp29_, _tmp30_, additional_rule->action, additional_rule->protocol, additional_rule->direction, additional_rule->version, NULL);
	}
	_tmp31_ = self->priv->settings;
	_tmp32_ = builder;
	_tmp33_ = g_variant_builder_end (_tmp32_);
	g_variant_ref_sink (_tmp33_);
	_tmp34_ = _tmp33_;
	g_settings_set_value (_tmp31_, "disabled-firewall-rules", _tmp34_);
	_g_variant_unref0 (_tmp34_);
	security_privacy_firewall_panel_load_disabled_rules (self);
	_g_variant_builder_unref0 (builder);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

void
security_privacy_firewall_panel_add_rule (SecurityPrivacyFirewallPanel* self,
                                          SecurityPrivacyUFWHelpersRule* rule,
                                          gboolean enabled,
                                          const gchar* hash)
{
	GtkTreeIter iter = {0};
	gchar* action = NULL;
	gchar* _tmp0_;
	gchar* protocol = NULL;
	gchar* _tmp5_;
	gchar* direction = NULL;
	gchar* _tmp9_;
	gchar* version = NULL;
	gchar* _tmp12_;
	gchar* from = NULL;
	gchar* _tmp15_;
	gchar* to = NULL;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp33_;
	GtkListStore* _tmp49_;
	GtkTreeIter _tmp50_ = {0};
	GtkListStore* _tmp51_;
	GtkTreeIter _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (rule != NULL);
	g_return_if_fail (hash != NULL);
	_tmp0_ = g_strdup (_ ("Unknown"));
	action = _tmp0_;
	if (rule->action == SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_ALLOW) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (_ ("Allow"));
		_g_free0 (action);
		action = _tmp1_;
	} else {
		if (rule->action == SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_DENY) {
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Deny"));
			_g_free0 (action);
			action = _tmp2_;
		} else {
			if (rule->action == SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_REJECT) {
				gchar* _tmp3_;
				_tmp3_ = g_strdup (_ ("Reject"));
				_g_free0 (action);
				action = _tmp3_;
			} else {
				if (rule->action == SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_LIMIT) {
					gchar* _tmp4_;
					_tmp4_ = g_strdup (_ ("Limit"));
					_g_free0 (action);
					action = _tmp4_;
				}
			}
		}
	}
	_tmp5_ = g_strdup (_ ("Unknown"));
	protocol = _tmp5_;
	if (rule->protocol == SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_UDP) {
		gchar* _tmp6_;
		_tmp6_ = g_strdup ("UDP");
		_g_free0 (protocol);
		protocol = _tmp6_;
	} else {
		if (rule->protocol == SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_TCP) {
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("TCP");
			_g_free0 (protocol);
			protocol = _tmp7_;
		} else {
			if (rule->protocol == SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_BOTH) {
				gchar* _tmp8_;
				_tmp8_ = g_strdup ("TCP/UDP");
				_g_free0 (protocol);
				protocol = _tmp8_;
			}
		}
	}
	_tmp9_ = g_strdup (_ ("Unknown"));
	direction = _tmp9_;
	if (rule->direction == SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_IN) {
		gchar* _tmp10_;
		_tmp10_ = g_strdup (_ ("In"));
		_g_free0 (direction);
		direction = _tmp10_;
	} else {
		if (rule->direction == SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_OUT) {
			gchar* _tmp11_;
			_tmp11_ = g_strdup (_ ("Out"));
			_g_free0 (direction);
			direction = _tmp11_;
		}
	}
	_tmp12_ = g_strdup (_ ("Unknown"));
	version = _tmp12_;
	if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6) {
		gchar* _tmp13_;
		_tmp13_ = g_strdup ("IPv6");
		_g_free0 (version);
		version = _tmp13_;
	} else {
		if (rule->version == SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4) {
			gchar* _tmp14_;
			_tmp14_ = g_strdup ("IPv4");
			_g_free0 (version);
			version = _tmp14_;
		}
	}
	_tmp15_ = g_strdup ("");
	from = _tmp15_;
	_tmp16_ = g_strdup ("");
	to = _tmp16_;
	_tmp17_ = rule->from_ports;
	if (g_strcmp0 (_tmp17_, "") != 0) {
		gboolean _tmp18_ = FALSE;
		const gchar* _tmp19_;
		_tmp19_ = rule->from_ports;
		if (string_contains (_tmp19_, ":")) {
			_tmp18_ = TRUE;
		} else {
			const gchar* _tmp20_;
			_tmp20_ = rule->from_ports;
			_tmp18_ = string_contains (_tmp20_, ",");
		}
		if (_tmp18_) {
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			_tmp21_ = rule->from;
			_tmp22_ = rule->from_ports;
			_tmp23_ = string_replace (_tmp22_, ":", "-");
			_tmp24_ = _tmp23_;
			_tmp25_ = g_strdup_printf (_ ("%s Ports %s"), _tmp21_, _tmp24_);
			_g_free0 (from);
			from = _tmp25_;
			_g_free0 (_tmp24_);
		} else {
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			_tmp26_ = rule->from;
			_tmp27_ = rule->from_ports;
			_tmp28_ = string_replace (_tmp27_, ":", "-");
			_tmp29_ = _tmp28_;
			_tmp30_ = g_strdup_printf (_ ("%s Port %s"), _tmp26_, _tmp29_);
			_g_free0 (from);
			from = _tmp30_;
			_g_free0 (_tmp29_);
		}
	} else {
		const gchar* _tmp31_;
		gchar* _tmp32_;
		_tmp31_ = rule->from;
		_tmp32_ = g_strdup (_tmp31_);
		_g_free0 (from);
		from = _tmp32_;
	}
	_tmp33_ = rule->to_ports;
	if (g_strcmp0 (_tmp33_, "") != 0) {
		gboolean _tmp34_ = FALSE;
		const gchar* _tmp35_;
		_tmp35_ = rule->to_ports;
		if (string_contains (_tmp35_, ":")) {
			_tmp34_ = TRUE;
		} else {
			const gchar* _tmp36_;
			_tmp36_ = rule->to_ports;
			_tmp34_ = string_contains (_tmp36_, ",");
		}
		if (_tmp34_) {
			const gchar* _tmp37_;
			const gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			_tmp37_ = rule->to;
			_tmp38_ = rule->to_ports;
			_tmp39_ = string_replace (_tmp38_, ":", "-");
			_tmp40_ = _tmp39_;
			_tmp41_ = g_strdup_printf (_ ("%s Ports %s"), _tmp37_, _tmp40_);
			_g_free0 (to);
			to = _tmp41_;
			_g_free0 (_tmp40_);
		} else {
			const gchar* _tmp42_;
			const gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			_tmp42_ = rule->to;
			_tmp43_ = rule->to_ports;
			_tmp44_ = string_replace (_tmp43_, ":", "-");
			_tmp45_ = _tmp44_;
			_tmp46_ = g_strdup_printf (_ ("%s Port %s"), _tmp42_, _tmp45_);
			_g_free0 (to);
			to = _tmp46_;
			_g_free0 (_tmp45_);
		}
	} else {
		const gchar* _tmp47_;
		gchar* _tmp48_;
		_tmp47_ = rule->to;
		_tmp48_ = g_strdup (_tmp47_);
		_g_free0 (to);
		to = _tmp48_;
	}
	_tmp49_ = self->priv->list_store;
	gtk_list_store_append (_tmp49_, &_tmp50_);
	iter = _tmp50_;
	_tmp51_ = self->priv->list_store;
	_tmp52_ = iter;
	_tmp53_ = action;
	_tmp54_ = protocol;
	_tmp55_ = direction;
	_tmp56_ = version;
	_tmp57_ = to;
	_tmp58_ = string_strip (_tmp57_);
	_tmp59_ = _tmp58_;
	_tmp60_ = from;
	_tmp61_ = string_strip (_tmp60_);
	_tmp62_ = _tmp61_;
	gtk_list_store_set (_tmp51_, &_tmp52_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION, _tmp53_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL, _tmp54_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION, _tmp55_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6, _tmp56_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, enabled, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, rule, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO, _tmp59_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM, _tmp62_, -1);
	_g_free0 (_tmp62_);
	_g_free0 (_tmp59_);
	_g_free0 (to);
	_g_free0 (from);
	_g_free0 (version);
	_g_free0 (direction);
	_g_free0 (protocol);
	_g_free0 (action);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		SecurityPrivacyFirewallPanel* self;
		self = _data4_->self;
		_g_object_unref0 (_data4_->add_button);
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static void
__lambda10_ (SecurityPrivacyFirewallPanel* self,
             const gchar* path)
{
	GValue active = {0};
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_;
	GValue _tmp6_ = {0};
	gboolean is_active = FALSE;
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	GValue rule_value = {0};
	GtkListStore* _tmp9_;
	GtkTreeIter _tmp10_;
	GValue _tmp11_ = {0};
	SecurityPrivacyUFWHelpersRule* rule = NULL;
	GObject* _tmp12_;
	SecurityPrivacyUFWHelpersRule* _tmp13_;
	gchar* gen_hash = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp14_;
	gchar* _tmp15_;
	g_return_if_fail (path != NULL);
	_tmp0_ = self->priv->list_store;
	_tmp1_ = gtk_tree_path_new_from_string (path);
	_tmp2_ = _tmp1_;
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp0_, &_tmp3_, _tmp2_);
	iter = _tmp3_;
	__vala_GtkTreePath_free0 (_tmp2_);
	_tmp4_ = self->priv->list_store;
	_tmp5_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp4_, &_tmp5_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, &_tmp6_);
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
	active = _tmp6_;
	is_active = !g_value_get_boolean (&active);
	_tmp7_ = self->priv->list_store;
	_tmp8_ = iter;
	gtk_list_store_set (_tmp7_, &_tmp8_, SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, is_active, -1);
	_tmp9_ = self->priv->list_store;
	_tmp10_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp9_, &_tmp10_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp11_);
	G_IS_VALUE (&rule_value) ? (g_value_unset (&rule_value), NULL) : NULL;
	rule_value = _tmp11_;
	_tmp12_ = g_value_get_object (&rule_value);
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, SecurityPrivacyUFWHelpersRule));
	rule = _tmp13_;
	_tmp14_ = rule;
	_tmp15_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp14_);
	gen_hash = _tmp15_;
	if (is_active == FALSE) {
		SecurityPrivacyUFWHelpersRule* _tmp16_;
		_tmp16_ = rule;
		security_privacy_firewall_panel_disable_rule (self, _tmp16_);
	} else {
		const gchar* _tmp17_;
		_tmp17_ = gen_hash;
		security_privacy_firewall_panel_enable_rule (self, _tmp17_);
	}
	security_privacy_firewall_panel_reload_rule_numbers (self);
	_g_free0 (gen_hash);
	_g_object_unref0 (rule);
	G_IS_VALUE (&rule_value) ? (g_value_unset (&rule_value), NULL) : NULL;
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
}

static void
___lambda10__gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender,
                                               const gchar* path,
                                               gpointer self)
{
	__lambda10_ ((SecurityPrivacyFirewallPanel*) self, path);
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		SecurityPrivacyFirewallPanel* self;
		self = _data5_->_data4_->self;
		_g_object_unref0 (_data5_->ports_entry);
		_g_object_unref0 (_data5_->direction_combobox);
		_g_object_unref0 (_data5_->version_combobox);
		_g_object_unref0 (_data5_->protocol_combobox);
		_g_object_unref0 (_data5_->policy_combobox);
		block4_data_unref (_data5_->_data4_);
		_data5_->_data4_ = NULL;
		g_slice_free (Block5Data, _data5_);
	}
}

static void
__lambda12_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	SecurityPrivacyFirewallPanel* self;
	SecurityPrivacyUFWHelpersRule* rule = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp19_;
	gint _tmp20_;
	SecurityPrivacyUFWHelpersRule* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	SecurityPrivacyUFWHelpersRule* _tmp30_;
	GtkPopover* _tmp31_;
	_data4_ = _data5_->_data4_;
	self = _data4_->self;
	_tmp0_ = security_privacy_ufw_helpers_rule_new ();
	rule = _tmp0_;
	_tmp1_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->direction_combobox);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		SecurityPrivacyUFWHelpersRule* _tmp3_;
		_tmp3_ = rule;
		_tmp3_->direction = SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_IN;
	} else {
		SecurityPrivacyUFWHelpersRule* _tmp4_;
		_tmp4_ = rule;
		_tmp4_->direction = SECURITY_PRIVACY_UFW_HELPERS_RULE_DIRECTION_OUT;
	}
	_tmp5_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->protocol_combobox);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == 0) {
		SecurityPrivacyUFWHelpersRule* _tmp7_;
		_tmp7_ = rule;
		_tmp7_->protocol = SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_TCP;
	} else {
		SecurityPrivacyUFWHelpersRule* _tmp8_;
		_tmp8_ = rule;
		_tmp8_->protocol = SECURITY_PRIVACY_UFW_HELPERS_RULE_PROTOCOL_UDP;
	}
	_tmp9_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->policy_combobox);
	_tmp10_ = _tmp9_;
	if (_tmp10_ == 0) {
		SecurityPrivacyUFWHelpersRule* _tmp11_;
		_tmp11_ = rule;
		_tmp11_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_ALLOW;
	} else {
		gint _tmp12_;
		gint _tmp13_;
		_tmp12_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->policy_combobox);
		_tmp13_ = _tmp12_;
		if (_tmp13_ == 1) {
			SecurityPrivacyUFWHelpersRule* _tmp14_;
			_tmp14_ = rule;
			_tmp14_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_DENY;
		} else {
			gint _tmp15_;
			gint _tmp16_;
			_tmp15_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->policy_combobox);
			_tmp16_ = _tmp15_;
			if (_tmp16_ == 2) {
				SecurityPrivacyUFWHelpersRule* _tmp17_;
				_tmp17_ = rule;
				_tmp17_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_REJECT;
			} else {
				SecurityPrivacyUFWHelpersRule* _tmp18_;
				_tmp18_ = rule;
				_tmp18_->action = SECURITY_PRIVACY_UFW_HELPERS_RULE_ACTION_LIMIT;
			}
		}
	}
	_tmp19_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->version_combobox);
	_tmp20_ = _tmp19_;
	if (_tmp20_ == 0) {
		SecurityPrivacyUFWHelpersRule* _tmp21_;
		_tmp21_ = rule;
		_tmp21_->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV4;
	} else {
		gint _tmp22_;
		gint _tmp23_;
		_tmp22_ = gtk_combo_box_get_active ((GtkComboBox*) _data5_->version_combobox);
		_tmp23_ = _tmp22_;
		if (_tmp23_ == 1) {
			SecurityPrivacyUFWHelpersRule* _tmp24_;
			_tmp24_ = rule;
			_tmp24_->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_IPV6;
		} else {
			SecurityPrivacyUFWHelpersRule* _tmp25_;
			_tmp25_ = rule;
			_tmp25_->version = SECURITY_PRIVACY_UFW_HELPERS_RULE_VERSION_BOTH;
		}
	}
	_tmp26_ = rule;
	_tmp27_ = gtk_entry_get_text (_data5_->ports_entry);
	_tmp28_ = _tmp27_;
	_tmp29_ = string_replace (_tmp28_, "-", ":");
	_g_free0 (_tmp26_->to_ports);
	_tmp26_->to_ports = _tmp29_;
	_tmp30_ = rule;
	security_privacy_ufw_helpers_add_rule (_tmp30_);
	_tmp31_ = self->priv->add_popover;
	gtk_widget_hide ((GtkWidget*) _tmp31_);
	security_privacy_firewall_panel_show_rules (self);
	_g_object_unref0 (rule);
}

static void
___lambda12__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda12_ (self);
}

static void
__lambda11_ (Block4Data* _data4_)
{
	SecurityPrivacyFirewallPanel* self;
	Block5Data* _data5_;
	GtkGrid* popover_grid = NULL;
	GtkGrid* _tmp0_;
	GtkPopover* _tmp1_;
	GtkPopover* _tmp2_;
	GtkLabel* policy_label = NULL;
	GtkLabel* _tmp3_;
	GtkComboBoxText* _tmp4_;
	GtkLabel* protocol_label = NULL;
	GtkLabel* _tmp5_;
	GtkComboBoxText* _tmp6_;
	GtkLabel* version_label = NULL;
	GtkLabel* _tmp7_;
	GtkComboBoxText* _tmp8_;
	GtkLabel* direction_label = NULL;
	GtkLabel* _tmp9_;
	GtkComboBoxText* _tmp10_;
	GtkLabel* ports_label = NULL;
	GtkLabel* _tmp11_;
	GtkEntry* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkButton* do_add_button = NULL;
	GtkButton* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkGrid* add_button_grid = NULL;
	GtkGrid* _tmp17_;
	GtkPopover* _tmp18_;
	self = _data4_->self;
	_data5_ = g_slice_new0 (Block5Data);
	_data5_->_ref_count_ = 1;
	_data5_->_data4_ = block4_data_ref (_data4_);
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp0_);
	popover_grid = _tmp0_;
	g_object_set ((GtkWidget*) popover_grid, "margin", 6, NULL);
	gtk_widget_set_margin_top ((GtkWidget*) popover_grid, 12);
	gtk_widget_set_margin_start ((GtkWidget*) popover_grid, 12);
	gtk_widget_set_margin_bottom ((GtkWidget*) popover_grid, 9);
	gtk_grid_set_column_spacing (popover_grid, 12);
	gtk_grid_set_row_spacing (popover_grid, 6);
	_tmp1_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) _data4_->add_button);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->add_popover);
	self->priv->add_popover = _tmp1_;
	_tmp2_ = self->priv->add_popover;
	gtk_container_add ((GtkContainer*) _tmp2_, (GtkWidget*) popover_grid);
	_tmp3_ = (GtkLabel*) gtk_label_new (_ ("Action:"));
	g_object_ref_sink (_tmp3_);
	policy_label = _tmp3_;
	gtk_label_set_xalign (policy_label, (gfloat) 1);
	_tmp4_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp4_);
	_data5_->policy_combobox = _tmp4_;
	gtk_combo_box_text_append_text (_data5_->policy_combobox, _ ("Allow"));
	gtk_combo_box_text_append_text (_data5_->policy_combobox, _ ("Deny"));
	gtk_combo_box_text_append_text (_data5_->policy_combobox, _ ("Reject"));
	gtk_combo_box_text_append_text (_data5_->policy_combobox, _ ("Limit"));
	gtk_combo_box_set_active ((GtkComboBox*) _data5_->policy_combobox, 0);
	_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Protocol:"));
	g_object_ref_sink (_tmp5_);
	protocol_label = _tmp5_;
	gtk_label_set_xalign (protocol_label, (gfloat) 1);
	_tmp6_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp6_);
	_data5_->protocol_combobox = _tmp6_;
	gtk_combo_box_text_append_text (_data5_->protocol_combobox, "TCP");
	gtk_combo_box_text_append_text (_data5_->protocol_combobox, "UDP");
	gtk_combo_box_set_active ((GtkComboBox*) _data5_->protocol_combobox, 0);
	_tmp7_ = (GtkLabel*) gtk_label_new (_ ("Version:"));
	g_object_ref_sink (_tmp7_);
	version_label = _tmp7_;
	gtk_label_set_xalign (version_label, (gfloat) 1);
	_tmp8_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp8_);
	_data5_->version_combobox = _tmp8_;
	gtk_combo_box_text_append_text (_data5_->version_combobox, "IPv4");
	gtk_combo_box_text_append_text (_data5_->version_combobox, "IPv6");
	gtk_combo_box_text_append_text (_data5_->version_combobox, _ ("Both"));
	gtk_combo_box_set_active ((GtkComboBox*) _data5_->version_combobox, 0);
	_tmp9_ = (GtkLabel*) gtk_label_new (_ ("Direction:"));
	g_object_ref_sink (_tmp9_);
	direction_label = _tmp9_;
	gtk_label_set_xalign (direction_label, (gfloat) 1);
	_tmp10_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp10_);
	_data5_->direction_combobox = _tmp10_;
	gtk_combo_box_text_append_text (_data5_->direction_combobox, _ ("In"));
	gtk_combo_box_text_append_text (_data5_->direction_combobox, _ ("Out"));
	gtk_combo_box_set_active ((GtkComboBox*) _data5_->direction_combobox, 0);
	_tmp11_ = (GtkLabel*) gtk_label_new (_ ("Ports:"));
	g_object_ref_sink (_tmp11_);
	ports_label = _tmp11_;
	gtk_label_set_xalign (ports_label, (gfloat) 1);
	_tmp12_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp12_);
	_data5_->ports_entry = _tmp12_;
	gtk_entry_set_input_purpose (_data5_->ports_entry, GTK_INPUT_PURPOSE_NUMBER);
	_tmp13_ = g_strdup_printf (_ ("%d or %d-%d"), 80, 80, 85);
	_tmp14_ = _tmp13_;
	gtk_entry_set_placeholder_text (_data5_->ports_entry, _tmp14_);
	_g_free0 (_tmp14_);
	_tmp15_ = (GtkButton*) gtk_button_new_with_label (_ ("Add Rule"));
	g_object_ref_sink (_tmp15_);
	do_add_button = _tmp15_;
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) do_add_button);
	gtk_style_context_add_class (_tmp16_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	g_signal_connect_data (do_add_button, "clicked", (GCallback) ___lambda12__gtk_button_clicked, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp17_);
	add_button_grid = _tmp17_;
	gtk_container_add ((GtkContainer*) add_button_grid, (GtkWidget*) do_add_button);
	gtk_widget_set_halign ((GtkWidget*) add_button_grid, GTK_ALIGN_END);
	gtk_grid_attach (popover_grid, (GtkWidget*) policy_label, 0, 0, 1, 1);
	gtk_grid_attach (popover_grid, (GtkWidget*) _data5_->policy_combobox, 1, 0, 1, 1);
	gtk_grid_attach (popover_grid, (GtkWidget*) protocol_label, 0, 1, 1, 1);
	gtk_grid_attach (popover_grid, (GtkWidget*) _data5_->protocol_combobox, 1, 1, 1, 1);
	gtk_grid_attach (popover_grid, (GtkWidget*) version_label, 0, 2, 1, 1);
	gtk_grid_attach (popover_grid, (GtkWidget*) _data5_->version_combobox, 1, 2, 1, 1);
	gtk_grid_attach (popover_grid, (GtkWidget*) direction_label, 0, 3, 1, 1);
	gtk_grid_attach (popover_grid, (GtkWidget*) _data5_->direction_combobox, 1, 3, 1, 1);
	gtk_grid_attach (popover_grid, (GtkWidget*) ports_label, 0, 4, 1, 1);
	gtk_grid_attach (popover_grid, (GtkWidget*) _data5_->ports_entry, 1, 4, 1, 1);
	gtk_grid_attach (popover_grid, (GtkWidget*) add_button_grid, 0, 5, 2, 1);
	_tmp18_ = self->priv->add_popover;
	gtk_widget_show_all ((GtkWidget*) _tmp18_);
	_g_object_unref0 (add_button_grid);
	_g_object_unref0 (do_add_button);
	_g_object_unref0 (ports_label);
	_g_object_unref0 (direction_label);
	_g_object_unref0 (version_label);
	_g_object_unref0 (protocol_label);
	_g_object_unref0 (policy_label);
	_g_object_unref0 (popover_grid);
	block5_data_unref (_data5_);
	_data5_ = NULL;
}

static void
___lambda11__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda11_ (self);
}

static void
__lambda13_ (SecurityPrivacyFirewallPanel* self)
{
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	GtkTreeView* _tmp0_;
	GtkTreePath* _tmp1_ = NULL;
	GtkTreeViewColumn* _tmp2_ = NULL;
	GtkTreeViewColumn* _tmp3_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	GValue val = {0};
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	GValue _tmp9_ = {0};
	SecurityPrivacyUFWHelpersRule* rule = NULL;
	GObject* _tmp10_;
	SecurityPrivacyUFWHelpersRule* _tmp11_;
	gchar* gen_hash = NULL;
	SecurityPrivacyUFWHelpersRule* _tmp12_;
	gchar* _tmp13_;
	GValue active = {0};
	GtkListStore* _tmp14_;
	GtkTreeIter _tmp15_;
	GValue _tmp16_ = {0};
	_tmp0_ = self->priv->view;
	gtk_tree_view_get_cursor (_tmp0_, &_tmp1_, &_tmp2_);
	__vala_GtkTreePath_free0 (path);
	path = _tmp1_;
	_g_object_unref0 (column);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	column = _tmp3_;
	_tmp4_ = self->priv->list_store;
	_tmp5_ = path;
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp4_, &_tmp6_, _tmp5_);
	iter = _tmp6_;
	_tmp7_ = self->priv->list_store;
	_tmp8_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp7_, &_tmp8_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_RULE, &_tmp9_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp9_;
	_tmp10_ = g_value_get_object (&val);
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, SecurityPrivacyUFWHelpersRule));
	rule = _tmp11_;
	_tmp12_ = rule;
	_tmp13_ = security_privacy_firewall_panel_generate_hash_for_rule (self, _tmp12_);
	gen_hash = _tmp13_;
	_tmp14_ = self->priv->list_store;
	_tmp15_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp14_, &_tmp15_, (gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, &_tmp16_);
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
	active = _tmp16_;
	if (g_value_get_boolean (&active)) {
		SecurityPrivacyUFWHelpersRule* _tmp17_;
		_tmp17_ = rule;
		security_privacy_ufw_helpers_remove_rule (_tmp17_);
	} else {
		const gchar* _tmp18_;
		_tmp18_ = gen_hash;
		security_privacy_firewall_panel_delete_disabled_rule (self, _tmp18_);
	}
	security_privacy_firewall_panel_show_rules (self);
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
	_g_free0 (gen_hash);
	_g_object_unref0 (rule);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	_g_object_unref0 (column);
	__vala_GtkTreePath_free0 (path);
}

static void
___lambda13__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
	__lambda13_ ((SecurityPrivacyFirewallPanel*) self);
}

static void
__lambda14_ (SecurityPrivacyFirewallPanel* self)
{
	GtkButton* _tmp0_;
	_tmp0_ = self->priv->remove_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, TRUE);
}

static void
___lambda14__gtk_tree_view_cursor_changed (GtkTreeView* _sender,
                                           gpointer self)
{
	__lambda14_ ((SecurityPrivacyFirewallPanel*) self);
}

static void
security_privacy_firewall_panel_create_treeview (SecurityPrivacyFirewallPanel* self)
{
	Block4Data* _data4_;
	GtkListStore* _tmp0_;
	GtkListStore* _tmp1_;
	GtkTreeView* _tmp2_;
	GtkTreeView* _tmp3_;
	GtkTreeView* _tmp4_;
	GtkCellRendererToggle* celltoggle = NULL;
	GtkCellRendererToggle* _tmp5_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp6_;
	GtkTreeView* _tmp7_;
	GtkTreeView* _tmp8_;
	GtkTreeView* _tmp9_;
	GtkTreeView* _tmp10_;
	GtkTreeView* _tmp11_;
	GtkTreeView* _tmp12_;
	GtkTreeView* _tmp13_;
	GtkActionBar* _tmp14_;
	GtkActionBar* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkButton* _tmp17_;
	GtkActionBar* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GtkButton* _tmp21_;
	GtkActionBar* _tmp22_;
	GtkButton* _tmp23_;
	GtkTreeView* _tmp24_;
	GtkGrid* view_grid = NULL;
	GtkGrid* _tmp25_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp26_;
	GtkTreeView* _tmp27_;
	GtkActionBar* _tmp28_;
	GtkFrame* frame = NULL;
	GtkFrame* _tmp29_;
	GtkGrid* _tmp30_;
	GtkGrid* _tmp31_;
	g_return_if_fail (self != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_tmp0_ = gtk_list_store_new ((gint) SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_N_COLUMNS, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_BOOLEAN, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, -1);
	_g_object_unref0 (self->priv->list_store);
	self->priv->list_store = _tmp0_;
	_tmp1_ = self->priv->list_store;
	_tmp2_ = (GtkTreeView*) gtk_tree_view_new_with_model ((GtkTreeModel*) _tmp1_);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->view);
	self->priv->view = _tmp2_;
	_tmp3_ = self->priv->view;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp3_, TRUE);
	_tmp4_ = self->priv->view;
	gtk_tree_view_set_activate_on_single_click (_tmp4_, TRUE);
	_tmp5_ = (GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ();
	g_object_ref_sink (_tmp5_);
	celltoggle = _tmp5_;
	_tmp6_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp6_);
	cell = _tmp6_;
	_tmp7_ = self->priv->view;
	gtk_tree_view_insert_column_with_attributes (_tmp7_, -1, _ ("Enabled"), (GtkCellRenderer*) celltoggle, "active", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ENABLED, NULL);
	_tmp8_ = self->priv->view;
	gtk_tree_view_insert_column_with_attributes (_tmp8_, -1, _ ("Version"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_V6, NULL);
	_tmp9_ = self->priv->view;
	gtk_tree_view_insert_column_with_attributes (_tmp9_, -1, _ ("Action"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_ACTION, NULL);
	_tmp10_ = self->priv->view;
	gtk_tree_view_insert_column_with_attributes (_tmp10_, -1, _ ("Protocol"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_PROTOCOL, NULL);
	_tmp11_ = self->priv->view;
	gtk_tree_view_insert_column_with_attributes (_tmp11_, -1, _ ("Direction"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_DIRECTION, NULL);
	_tmp12_ = self->priv->view;
	gtk_tree_view_insert_column_with_attributes (_tmp12_, -1, _ ("To"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_TO, NULL);
	_tmp13_ = self->priv->view;
	gtk_tree_view_insert_column_with_attributes (_tmp13_, -1, _ ("From"), (GtkCellRenderer*) cell, "text", SECURITY_PRIVACY_FIREWALL_PANEL_COLUMNS_FROM, NULL);
	g_signal_connect_object (celltoggle, "toggled", (GCallback) ___lambda10__gtk_cell_renderer_toggle_toggled, self, 0);
	_tmp14_ = (GtkActionBar*) gtk_action_bar_new ();
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->actionbar);
	self->priv->actionbar = _tmp14_;
	_tmp15_ = self->priv->actionbar;
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
	gtk_style_context_add_class (_tmp16_, GTK_STYLE_CLASS_INLINE_TOOLBAR);
	_tmp17_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp17_);
	_data4_->add_button = _tmp17_;
	g_signal_connect_data (_data4_->add_button, "clicked", (GCallback) ___lambda11__gtk_button_clicked, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
	_tmp18_ = self->priv->actionbar;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _data4_->add_button);
	_tmp19_ = (GtkButton*) gtk_button_new_from_icon_name ("list-remove-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->remove_button);
	self->priv->remove_button = _tmp19_;
	_tmp20_ = self->priv->remove_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp20_, FALSE);
	_tmp21_ = self->priv->remove_button;
	g_signal_connect_object (_tmp21_, "clicked", (GCallback) ___lambda13__gtk_button_clicked, self, 0);
	_tmp22_ = self->priv->actionbar;
	_tmp23_ = self->priv->remove_button;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = self->priv->view;
	g_signal_connect_object (_tmp24_, "cursor-changed", (GCallback) ___lambda14__gtk_tree_view_cursor_changed, self, 0);
	_tmp25_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp25_);
	view_grid = _tmp25_;
	_tmp26_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp26_);
	scrolled = _tmp26_;
	g_object_set ((GtkWidget*) scrolled, "expand", TRUE, NULL);
	_tmp27_ = self->priv->view;
	gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) _tmp27_);
	gtk_grid_attach (view_grid, (GtkWidget*) scrolled, 0, 0, 1, 1);
	_tmp28_ = self->priv->actionbar;
	gtk_grid_attach (view_grid, (GtkWidget*) _tmp28_, 0, 1, 1, 1);
	_tmp29_ = (GtkFrame*) gtk_frame_new (NULL);
	g_object_ref_sink (_tmp29_);
	frame = _tmp29_;
	gtk_container_add ((GtkContainer*) frame, (GtkWidget*) view_grid);
	_tmp30_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp31_ = _tmp30_;
	gtk_grid_attach (_tmp31_, (GtkWidget*) frame, 0, 1, 3, 1);
	_g_object_unref0 (frame);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (view_grid);
	_g_object_unref0 (cell);
	_g_object_unref0 (celltoggle);
	block4_data_unref (_data4_);
	_data4_ = NULL;
}

static void
_security_privacy_firewall_panel___lambda15_ (SecurityPrivacyFirewallPanel* self)
{
	GtkSwitch* _tmp9_;
	GtkSwitch* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	if (self->priv->loading == FALSE) {
		GtkTreeView* _tmp0_;
		GtkSwitch* _tmp1_;
		GtkSwitch* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		GtkSwitch* _tmp5_;
		GtkSwitch* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp0_ = self->priv->view;
		_tmp1_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
		_tmp2_ = _tmp1_;
		_tmp3_ = gtk_switch_get_active (_tmp2_);
		_tmp4_ = _tmp3_;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp4_);
		_tmp5_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
		_tmp6_ = _tmp5_;
		_tmp7_ = gtk_switch_get_active (_tmp6_);
		_tmp8_ = _tmp7_;
		security_privacy_ufw_helpers_set_status (_tmp8_);
	}
	_tmp9_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
	_tmp10_ = _tmp9_;
	_tmp11_ = gtk_switch_get_active (_tmp10_);
	_tmp12_ = _tmp11_;
	if (_tmp12_) {
		granite_settings_page_set_status_type ((GraniteSettingsPage*) self, GRANITE_SETTINGS_PAGE_STATUS_TYPE_SUCCESS);
		granite_settings_page_set_status ((GraniteSettingsPage*) self, _ ("Enabled"));
	} else {
		g_warning ("FirewallPanel.vala:66: Trying to set offline");
		granite_settings_page_set_status_type ((GraniteSettingsPage*) self, GRANITE_SETTINGS_PAGE_STATUS_TYPE_OFFLINE);
		granite_settings_page_set_status ((GraniteSettingsPage*) self, _ ("Disabled"));
	}
	security_privacy_firewall_panel_show_rules (self);
}

static void
__security_privacy_firewall_panel___lambda15__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
	_security_privacy_firewall_panel___lambda15_ ((SecurityPrivacyFirewallPanel*) self);
}

static void
_security_privacy_firewall_panel___lambda16_ (SecurityPrivacyFirewallPanel* self)
{
	GtkLockButton* _tmp0_;
	GPermission* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkSwitch* _tmp4_;
	GtkSwitch* _tmp5_;
	GtkListStore* _tmp6_;
	GtkButton* _tmp7_;
	GtkSwitch* _tmp8_;
	GtkSwitch* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	self->priv->loading = TRUE;
	_tmp0_ = security_privacy_lock_button;
	_tmp1_ = gtk_lock_button_get_permission (_tmp0_);
	_tmp2_ = g_permission_get_allowed (_tmp1_);
	_tmp3_ = _tmp2_;
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp3_);
	_tmp4_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
	_tmp5_ = _tmp4_;
	gtk_switch_set_active (_tmp5_, security_privacy_ufw_helpers_get_status ());
	_tmp6_ = self->priv->list_store;
	gtk_list_store_clear (_tmp6_);
	_tmp7_ = self->priv->remove_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, FALSE);
	_tmp8_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
	_tmp9_ = _tmp8_;
	_tmp10_ = gtk_switch_get_active (_tmp9_);
	_tmp11_ = _tmp10_;
	if (_tmp11_ == TRUE) {
		GtkTreeView* _tmp12_;
		_tmp12_ = self->priv->view;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, TRUE);
		security_privacy_firewall_panel_show_rules (self);
	} else {
		GtkTreeView* _tmp13_;
		_tmp13_ = self->priv->view;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, FALSE);
	}
	self->priv->loading = FALSE;
}

static void
__security_privacy_firewall_panel___lambda16__g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
	_security_privacy_firewall_panel___lambda16_ ((SecurityPrivacyFirewallPanel*) self);
}

static GObject *
security_privacy_firewall_panel_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SecurityPrivacyFirewallPanel * self;
	GSettings* _tmp0_;
	GeeHashMap* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkSwitch* _tmp3_;
	GtkLockButton* _tmp4_;
	GPermission* _tmp5_;
	parent_class = G_OBJECT_CLASS (security_privacy_firewall_panel_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_FIREWALL_PANEL, SecurityPrivacyFirewallPanel);
	_tmp0_ = g_settings_new ("io.elementary.switchboard.security-privacy");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SECURITY_PRIVACY_UFW_HELPERS_TYPE_RULE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->disabled_rules);
	self->priv->disabled_rules = _tmp1_;
	security_privacy_firewall_panel_load_disabled_rules (self);
	_tmp2_ = granite_simple_settings_page_get_status_switch ((GraniteSimpleSettingsPage*) self);
	_tmp3_ = _tmp2_;
	g_signal_connect_object ((GObject*) _tmp3_, "notify::active", (GCallback) __security_privacy_firewall_panel___lambda15__g_object_notify, self, 0);
	security_privacy_firewall_panel_create_treeview (self);
	gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
	_tmp4_ = security_privacy_lock_button;
	_tmp5_ = gtk_lock_button_get_permission (_tmp4_);
	g_signal_connect_object ((GObject*) _tmp5_, "notify::allowed", (GCallback) __security_privacy_firewall_panel___lambda16__g_object_notify, self, 0);
	return obj;
}

static void
security_privacy_firewall_panel_class_init (SecurityPrivacyFirewallPanelClass * klass,
                                            gpointer klass_data)
{
	security_privacy_firewall_panel_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyFirewallPanel_private_offset);
	G_OBJECT_CLASS (klass)->constructor = security_privacy_firewall_panel_constructor;
	G_OBJECT_CLASS (klass)->finalize = security_privacy_firewall_panel_finalize;
}

static void
security_privacy_firewall_panel_instance_init (SecurityPrivacyFirewallPanel * self,
                                               gpointer klass)
{
	self->priv = security_privacy_firewall_panel_get_instance_private (self);
	self->priv->loading = FALSE;
}

static void
security_privacy_firewall_panel_finalize (GObject * obj)
{
	SecurityPrivacyFirewallPanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_FIREWALL_PANEL, SecurityPrivacyFirewallPanel);
	_g_object_unref0 (self->priv->list_store);
	_g_object_unref0 (self->priv->view);
	_g_object_unref0 (self->priv->actionbar);
	_g_object_unref0 (self->priv->add_popover);
	_g_object_unref0 (self->priv->remove_button);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->disabled_rules);
	G_OBJECT_CLASS (security_privacy_firewall_panel_parent_class)->finalize (obj);
}

static GType
security_privacy_firewall_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyFirewallPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_firewall_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyFirewallPanel), 0, (GInstanceInitFunc) security_privacy_firewall_panel_instance_init, NULL };
	GType security_privacy_firewall_panel_type_id;
	security_privacy_firewall_panel_type_id = g_type_register_static (GRANITE_TYPE_SIMPLE_SETTINGS_PAGE, "SecurityPrivacyFirewallPanel", &g_define_type_info, 0);
	SecurityPrivacyFirewallPanel_private_offset = g_type_add_instance_private (security_privacy_firewall_panel_type_id, sizeof (SecurityPrivacyFirewallPanelPrivate));
	return security_privacy_firewall_panel_type_id;
}

GType
security_privacy_firewall_panel_get_type (void)
{
	static volatile gsize security_privacy_firewall_panel_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_firewall_panel_type_id__once)) {
		GType security_privacy_firewall_panel_type_id;
		security_privacy_firewall_panel_type_id = security_privacy_firewall_panel_get_type_once ();
		g_once_init_leave (&security_privacy_firewall_panel_type_id__once, security_privacy_firewall_panel_type_id);
	}
	return security_privacy_firewall_panel_type_id__once;
}

