/* HouseKeepingPanel.c generated by valac 0.56.8, the Vala compiler
 * generated from HouseKeepingPanel.vala, do not modify */

/*
 * Copyright (c) 2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

#include "security-privacy.h"
#include <granite.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

enum  {
	SECURITY_PRIVACY_HOUSE_KEEPING_PANEL_0_PROPERTY,
	SECURITY_PRIVACY_HOUSE_KEEPING_PANEL_NUM_PROPERTIES
};
static GParamSpec* security_privacy_house_keeping_panel_properties[SECURITY_PRIVACY_HOUSE_KEEPING_PANEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block6Data Block6Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SecurityPrivacyHouseKeepingPanelPrivate {
	GraniteHeaderLabel* spin_header_label;
	GtkLabel* file_age_label;
	GtkSpinButton* file_age_spinbutton;
	GtkCheckButton* download_files_check;
	GtkCheckButton* screenshot_files_check;
	GtkCheckButton* temp_files_switch;
	GtkCheckButton* trash_files_switch;
};

struct _Block6Data {
	int _ref_count_;
	SecurityPrivacyHouseKeepingPanel* self;
	GSettings* privacy_settings;
};

static gint SecurityPrivacyHouseKeepingPanel_private_offset;
static gpointer security_privacy_house_keeping_panel_parent_class = NULL;

static void security_privacy_house_keeping_panel_update_days (SecurityPrivacyHouseKeepingPanel* self,
                                                       guint age);
static void security_privacy_house_keeping_panel_update_status (SecurityPrivacyHouseKeepingPanel* self);
static GObject * security_privacy_house_keeping_panel_constructor (GType type,
                                                            guint n_construct_properties,
                                                            GObjectConstructParam * construct_properties);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void _security_privacy_house_keeping_panel_update_status_g_settings_changed (GSettings* _sender,
                                                                             const gchar* key,
                                                                             gpointer self);
static void _security_privacy_house_keeping_panel___lambda17_ (Block6Data* _data6_);
static void __security_privacy_house_keeping_panel___lambda17__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                                       gpointer self);
static void _security_privacy_house_keeping_panel___lambda18_ (SecurityPrivacyHouseKeepingPanel* self);
static void __security_privacy_house_keeping_panel___lambda18__gtk_button_clicked (GtkButton* _sender,
                                                                            gpointer self);
static void security_privacy_house_keeping_panel_finalize (GObject * obj);
static GType security_privacy_house_keeping_panel_get_type_once (void);

static inline gpointer
security_privacy_house_keeping_panel_get_instance_private (SecurityPrivacyHouseKeepingPanel* self)
{
	return G_STRUCT_MEMBER_P (self, SecurityPrivacyHouseKeepingPanel_private_offset);
}

SecurityPrivacyHouseKeepingPanel*
security_privacy_house_keeping_panel_construct (GType object_type)
{
	SecurityPrivacyHouseKeepingPanel * self = NULL;
	self = (SecurityPrivacyHouseKeepingPanel*) g_object_new (object_type, "description", "", "icon-name", "preferences-system-privacy-housekeeping", "title", _ ("Housekeeping"), NULL);
	return self;
}

SecurityPrivacyHouseKeepingPanel*
security_privacy_house_keeping_panel_new (void)
{
	return security_privacy_house_keeping_panel_construct (SECURITY_PRIVACY_TYPE_HOUSE_KEEPING_PANEL);
}

static void
security_privacy_house_keeping_panel_update_days (SecurityPrivacyHouseKeepingPanel* self,
                                                  guint age)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkLabel* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup_printf (g_dngettext (BUILD_GETTEXT_PACKAGE, "Old files can be automatically deleted after %u day to save space and " \
"help protect your privacy.", "Old files can be automatically deleted after %u days to save space and" \
" help protect your privacy.", (gulong) age), age);
	_tmp1_ = _tmp0_;
	granite_simple_settings_page_set_description ((GraniteSimpleSettingsPage*) self, _tmp1_);
	_g_free0 (_tmp1_);
	_tmp2_ = self->priv->file_age_label;
	gtk_label_set_label (_tmp2_, g_dngettext (BUILD_GETTEXT_PACKAGE, "Day", "Days", (gulong) age));
}

static void
security_privacy_house_keeping_panel_update_status (SecurityPrivacyHouseKeepingPanel* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GtkCheckButton* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean all_active = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	GtkCheckButton* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	gboolean any_active = FALSE;
	GtkLabel* _tmp30_;
	GtkSpinButton* _tmp31_;
	GraniteHeaderLabel* _tmp32_;
	g_return_if_fail (self != NULL);
	_tmp3_ = self->priv->temp_files_switch;
	_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		GtkCheckButton* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = self->priv->trash_files_switch;
		_tmp7_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp6_);
		_tmp8_ = _tmp7_;
		_tmp2_ = _tmp8_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GtkCheckButton* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		_tmp9_ = self->priv->download_files_check;
		_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
		_tmp11_ = _tmp10_;
		_tmp1_ = _tmp11_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GtkCheckButton* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
		_tmp12_ = self->priv->screenshot_files_check;
		_tmp13_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp12_);
		_tmp14_ = _tmp13_;
		_tmp0_ = _tmp14_;
	} else {
		_tmp0_ = FALSE;
	}
	all_active = _tmp0_;
	_tmp18_ = self->priv->temp_files_switch;
	_tmp19_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp18_);
	_tmp20_ = _tmp19_;
	if (_tmp20_) {
		_tmp17_ = TRUE;
	} else {
		GtkCheckButton* _tmp21_;
		gboolean _tmp22_;
		gboolean _tmp23_;
		_tmp21_ = self->priv->trash_files_switch;
		_tmp22_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp21_);
		_tmp23_ = _tmp22_;
		_tmp17_ = _tmp23_;
	}
	if (_tmp17_) {
		_tmp16_ = TRUE;
	} else {
		GtkCheckButton* _tmp24_;
		gboolean _tmp25_;
		gboolean _tmp26_;
		_tmp24_ = self->priv->download_files_check;
		_tmp25_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp24_);
		_tmp26_ = _tmp25_;
		_tmp16_ = _tmp26_;
	}
	if (_tmp16_) {
		_tmp15_ = TRUE;
	} else {
		GtkCheckButton* _tmp27_;
		gboolean _tmp28_;
		gboolean _tmp29_;
		_tmp27_ = self->priv->screenshot_files_check;
		_tmp28_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp27_);
		_tmp29_ = _tmp28_;
		_tmp15_ = _tmp29_;
	}
	any_active = _tmp15_;
	if (all_active) {
		granite_settings_page_set_status_type ((GraniteSettingsPage*) self, GRANITE_SETTINGS_PAGE_STATUS_TYPE_SUCCESS);
	} else {
		if (any_active) {
			granite_settings_page_set_status_type ((GraniteSettingsPage*) self, GRANITE_SETTINGS_PAGE_STATUS_TYPE_WARNING);
		} else {
			granite_settings_page_set_status_type ((GraniteSettingsPage*) self, GRANITE_SETTINGS_PAGE_STATUS_TYPE_OFFLINE);
		}
	}
	_tmp30_ = self->priv->file_age_label;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp30_, any_active);
	_tmp31_ = self->priv->file_age_spinbutton;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp31_, any_active);
	_tmp32_ = self->priv->spin_header_label;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp32_, any_active);
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		SecurityPrivacyHouseKeepingPanel* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->privacy_settings);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static void
_security_privacy_house_keeping_panel_update_status_g_settings_changed (GSettings* _sender,
                                                                        const gchar* key,
                                                                        gpointer self)
{
	security_privacy_house_keeping_panel_update_status ((SecurityPrivacyHouseKeepingPanel*) self);
}

static void
_security_privacy_house_keeping_panel___lambda17_ (Block6Data* _data6_)
{
	SecurityPrivacyHouseKeepingPanel* self;
	GtkSpinButton* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GSettings* _tmp3_;
	GtkSpinButton* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	self = _data6_->self;
	_tmp0_ = self->priv->file_age_spinbutton;
	_tmp1_ = gtk_spin_button_get_value (_tmp0_);
	_tmp2_ = _tmp1_;
	security_privacy_house_keeping_panel_update_days (self, (guint) _tmp2_);
	_tmp3_ = _data6_->privacy_settings;
	_tmp4_ = self->priv->file_age_spinbutton;
	_tmp5_ = gtk_spin_button_get_value (_tmp4_);
	_tmp6_ = _tmp5_;
	g_settings_set_uint (_tmp3_, "old-files-age", (guint) _tmp6_);
}

static void
__security_privacy_house_keeping_panel___lambda17__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                                  gpointer self)
{
	_security_privacy_house_keeping_panel___lambda17_ (self);
}

static void
_security_privacy_house_keeping_panel___lambda18_ (SecurityPrivacyHouseKeepingPanel* self)
{
	GError* _inner_error0_ = NULL;
	{
		g_app_info_launch_default_for_uri ("trash:///", NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_warning ("HouseKeepingPanel.vala:129: Failed to open trash: %s", _tmp1_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__security_privacy_house_keeping_panel___lambda18__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self)
{
	_security_privacy_house_keeping_panel___lambda18_ ((SecurityPrivacyHouseKeepingPanel*) self);
}

static GObject *
security_privacy_house_keeping_panel_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SecurityPrivacyHouseKeepingPanel * self;
	Block6Data* _data6_;
	GraniteHeaderLabel* switch_header_label = NULL;
	GraniteHeaderLabel* _tmp0_;
	GtkGrid* temp_files_grid = NULL;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GtkImage* _tmp3_;
	GtkImage* _tmp4_;
	GtkGrid* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkCheckButton* _tmp8_ = NULL;
	GtkCheckButton* _tmp9_;
	GtkGrid* _tmp10_;
	GtkGrid* download_files_grid = NULL;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkImage* _tmp13_;
	GtkImage* _tmp14_;
	GtkGrid* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkCheckButton* _tmp18_ = NULL;
	GtkCheckButton* _tmp19_;
	GtkGrid* _tmp20_;
	GtkGrid* screenshot_files_grid = NULL;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	GtkImage* _tmp23_;
	GtkImage* _tmp24_;
	GtkGrid* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkCheckButton* _tmp28_ = NULL;
	GtkCheckButton* _tmp29_;
	GtkGrid* _tmp30_;
	GtkGrid* trash_files_grid = NULL;
	GtkGrid* _tmp31_;
	GtkGrid* _tmp32_;
	GtkImage* _tmp33_;
	GtkImage* _tmp34_;
	GtkGrid* _tmp35_;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkCheckButton* _tmp38_ = NULL;
	GtkCheckButton* _tmp39_;
	GtkGrid* _tmp40_;
	GraniteHeaderLabel* _tmp41_;
	GtkSpinButton* _tmp42_;
	GtkSpinButton* _tmp43_;
	GtkSpinButton* _tmp44_;
	GtkSpinButton* _tmp45_;
	GtkLabel* _tmp46_;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkGrid* _tmp52_;
	GtkGrid* _tmp53_;
	GtkGrid* _tmp54_;
	GtkGrid* _tmp55_;
	GtkGrid* _tmp56_;
	GraniteHeaderLabel* _tmp57_;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	GtkCheckButton* _tmp60_;
	GtkGrid* _tmp61_;
	GtkGrid* _tmp62_;
	GtkCheckButton* _tmp63_;
	GtkGrid* _tmp64_;
	GtkGrid* _tmp65_;
	GtkCheckButton* _tmp66_;
	GtkGrid* _tmp67_;
	GtkGrid* _tmp68_;
	GtkCheckButton* _tmp69_;
	GtkGrid* _tmp70_;
	GtkGrid* _tmp71_;
	GraniteHeaderLabel* _tmp72_;
	GtkGrid* _tmp73_;
	GtkGrid* _tmp74_;
	GtkSpinButton* _tmp75_;
	GtkGrid* _tmp76_;
	GtkGrid* _tmp77_;
	GtkLabel* _tmp78_;
	GtkButton* view_trash_button = NULL;
	GtkButton* _tmp79_;
	GtkButtonBox* _tmp80_;
	GtkButtonBox* _tmp81_;
	GtkButton* _tmp82_;
	GSettings* _tmp83_;
	GSettings* _tmp84_;
	GtkCheckButton* _tmp85_;
	GSettings* _tmp86_;
	GtkCheckButton* _tmp87_;
	GSettings* _tmp88_;
	GSettings* housekeeping_settings = NULL;
	GSettings* _tmp89_;
	GSettings* _tmp90_;
	GtkCheckButton* _tmp91_;
	GSettings* _tmp92_;
	GtkCheckButton* _tmp93_;
	GSettings* _tmp94_;
	GtkSpinButton* _tmp95_;
	GSettings* _tmp96_;
	GtkSpinButton* _tmp97_;
	gdouble _tmp98_;
	gdouble _tmp99_;
	GtkSpinButton* _tmp100_;
	GtkButton* _tmp101_;
	parent_class = G_OBJECT_CLASS (security_privacy_house_keeping_panel_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_HOUSE_KEEPING_PANEL, SecurityPrivacyHouseKeepingPanel);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = granite_header_label_new (_ ("Automatically Delete:"));
	g_object_ref_sink (_tmp0_);
	switch_header_label = _tmp0_;
	_tmp1_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp1_);
	temp_files_grid = _tmp1_;
	_tmp2_ = temp_files_grid;
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("folder", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	gtk_container_add ((GtkContainer*) _tmp2_, (GtkWidget*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = temp_files_grid;
	_tmp6_ = (GtkLabel*) gtk_label_new (_ ("Old temporary files"));
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp7_);
	_g_object_unref0 (_tmp7_);
	_tmp8_ = (GtkCheckButton*) gtk_check_button_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_START);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp8_, 12);
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->temp_files_switch);
	self->priv->temp_files_switch = _tmp8_;
	_tmp9_ = self->priv->temp_files_switch;
	_tmp10_ = temp_files_grid;
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp11_);
	download_files_grid = _tmp11_;
	_tmp12_ = download_files_grid;
	_tmp13_ = (GtkImage*) gtk_image_new_from_icon_name ("folder-download", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp13_);
	_tmp14_ = _tmp13_;
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp14_);
	_g_object_unref0 (_tmp14_);
	_tmp15_ = download_files_grid;
	_tmp16_ = (GtkLabel*) gtk_label_new (_ ("Downloaded files"));
	g_object_ref_sink (_tmp16_);
	_tmp17_ = _tmp16_;
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp17_);
	_g_object_unref0 (_tmp17_);
	_tmp18_ = (GtkCheckButton*) gtk_check_button_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp18_, GTK_ALIGN_START);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp18_, 12);
	g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->download_files_check);
	self->priv->download_files_check = _tmp18_;
	_tmp19_ = self->priv->download_files_check;
	_tmp20_ = download_files_grid;
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
	_tmp21_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp21_);
	screenshot_files_grid = _tmp21_;
	_tmp22_ = screenshot_files_grid;
	_tmp23_ = (GtkImage*) gtk_image_new_from_icon_name ("folder-screenshots-icon", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp23_);
	_tmp24_ = _tmp23_;
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp24_);
	_g_object_unref0 (_tmp24_);
	_tmp25_ = screenshot_files_grid;
	_tmp26_ = (GtkLabel*) gtk_label_new (_ ("Screenshot files"));
	g_object_ref_sink (_tmp26_);
	_tmp27_ = _tmp26_;
	gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp27_);
	_g_object_unref0 (_tmp27_);
	_tmp28_ = (GtkCheckButton*) gtk_check_button_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp28_, GTK_ALIGN_START);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp28_, 12);
	g_object_ref_sink (_tmp28_);
	_g_object_unref0 (self->priv->screenshot_files_check);
	self->priv->screenshot_files_check = _tmp28_;
	_tmp29_ = self->priv->screenshot_files_check;
	_tmp30_ = screenshot_files_grid;
	gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp30_);
	_tmp31_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp31_);
	trash_files_grid = _tmp31_;
	_tmp32_ = trash_files_grid;
	_tmp33_ = (GtkImage*) gtk_image_new_from_icon_name ("user-trash-full", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp33_);
	_tmp34_ = _tmp33_;
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp34_);
	_g_object_unref0 (_tmp34_);
	_tmp35_ = trash_files_grid;
	_tmp36_ = (GtkLabel*) gtk_label_new (_ ("Trashed files"));
	g_object_ref_sink (_tmp36_);
	_tmp37_ = _tmp36_;
	gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp37_);
	_g_object_unref0 (_tmp37_);
	_tmp38_ = (GtkCheckButton*) gtk_check_button_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp38_, GTK_ALIGN_START);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp38_, 12);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp38_, 18);
	g_object_ref_sink (_tmp38_);
	_g_object_unref0 (self->priv->trash_files_switch);
	self->priv->trash_files_switch = _tmp38_;
	_tmp39_ = self->priv->trash_files_switch;
	_tmp40_ = trash_files_grid;
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
	_tmp41_ = granite_header_label_new (_ ("Delete Old Files After:"));
	g_object_ref_sink (_tmp41_);
	_g_object_unref0 (self->priv->spin_header_label);
	self->priv->spin_header_label = _tmp41_;
	_tmp42_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 90, (gdouble) 5);
	g_object_ref_sink (_tmp42_);
	_g_object_unref0 (self->priv->file_age_spinbutton);
	self->priv->file_age_spinbutton = _tmp42_;
	_tmp43_ = self->priv->file_age_spinbutton;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp43_, 12);
	_tmp44_ = self->priv->file_age_spinbutton;
	gtk_entry_set_max_length ((GtkEntry*) _tmp44_, 2);
	_tmp45_ = self->priv->file_age_spinbutton;
	g_object_set ((GtkEntry*) _tmp45_, "xalign", (gfloat) 1, NULL);
	_tmp46_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp46_);
	_g_object_unref0 (self->priv->file_age_label);
	self->priv->file_age_label = _tmp46_;
	_tmp47_ = self->priv->file_age_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp47_, GTK_ALIGN_START);
	_tmp48_ = self->priv->file_age_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp48_, TRUE);
	_tmp49_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp50_ = _tmp49_;
	_tmp51_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp52_ = _tmp51_;
	gtk_grid_set_row_spacing (_tmp52_, 6);
	gtk_grid_set_column_spacing (_tmp50_, 6);
	_tmp53_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp54_ = _tmp53_;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp54_, 60);
	_tmp55_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp56_ = _tmp55_;
	_tmp57_ = switch_header_label;
	gtk_grid_attach (_tmp56_, (GtkWidget*) _tmp57_, 0, 0, 2, 1);
	_tmp58_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp59_ = _tmp58_;
	_tmp60_ = self->priv->download_files_check;
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 0, 1, 2, 1);
	_tmp61_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp62_ = _tmp61_;
	_tmp63_ = self->priv->temp_files_switch;
	gtk_grid_attach (_tmp62_, (GtkWidget*) _tmp63_, 0, 2, 2, 1);
	_tmp64_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp65_ = _tmp64_;
	_tmp66_ = self->priv->screenshot_files_check;
	gtk_grid_attach (_tmp65_, (GtkWidget*) _tmp66_, 0, 3, 2, 1);
	_tmp67_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp68_ = _tmp67_;
	_tmp69_ = self->priv->trash_files_switch;
	gtk_grid_attach (_tmp68_, (GtkWidget*) _tmp69_, 0, 4, 2, 1);
	_tmp70_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp71_ = _tmp70_;
	_tmp72_ = self->priv->spin_header_label;
	gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, 0, 5, 2, 1);
	_tmp73_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp74_ = _tmp73_;
	_tmp75_ = self->priv->file_age_spinbutton;
	gtk_grid_attach (_tmp74_, (GtkWidget*) _tmp75_, 0, 6, 1, 1);
	_tmp76_ = granite_simple_settings_page_get_content_area ((GraniteSimpleSettingsPage*) self);
	_tmp77_ = _tmp76_;
	_tmp78_ = self->priv->file_age_label;
	gtk_grid_attach (_tmp77_, (GtkWidget*) _tmp78_, 1, 6, 1, 1);
	_tmp79_ = (GtkButton*) gtk_button_new_with_label (_ ("Open Trash…"));
	g_object_ref_sink (_tmp79_);
	view_trash_button = _tmp79_;
	_tmp80_ = granite_simple_settings_page_get_action_area ((GraniteSimpleSettingsPage*) self);
	_tmp81_ = _tmp80_;
	_tmp82_ = view_trash_button;
	gtk_container_add ((GtkContainer*) _tmp81_, (GtkWidget*) _tmp82_);
	_tmp83_ = g_settings_new ("org.gnome.desktop.privacy");
	_data6_->privacy_settings = _tmp83_;
	_tmp84_ = _data6_->privacy_settings;
	_tmp85_ = self->priv->temp_files_switch;
	g_settings_bind (_tmp84_, "remove-old-temp-files", (GObject*) _tmp85_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp86_ = _data6_->privacy_settings;
	_tmp87_ = self->priv->trash_files_switch;
	g_settings_bind (_tmp86_, "remove-old-trash-files", (GObject*) _tmp87_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp88_ = _data6_->privacy_settings;
	g_signal_connect_object (_tmp88_, "changed", (GCallback) _security_privacy_house_keeping_panel_update_status_g_settings_changed, self, 0);
	_tmp89_ = g_settings_new ("io.elementary.settings-daemon.housekeeping");
	housekeeping_settings = _tmp89_;
	_tmp90_ = housekeeping_settings;
	_tmp91_ = self->priv->download_files_check;
	g_settings_bind (_tmp90_, "cleanup-downloads-folder", (GObject*) _tmp91_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp92_ = housekeeping_settings;
	_tmp93_ = self->priv->screenshot_files_check;
	g_settings_bind (_tmp92_, "cleanup-screenshots-folder", (GObject*) _tmp93_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp94_ = housekeeping_settings;
	_tmp95_ = self->priv->file_age_spinbutton;
	g_settings_bind (_tmp94_, "old-files-age", (GObject*) _tmp95_, "value", G_SETTINGS_BIND_DEFAULT);
	_tmp96_ = housekeeping_settings;
	g_signal_connect_object (_tmp96_, "changed", (GCallback) _security_privacy_house_keeping_panel_update_status_g_settings_changed, self, 0);
	_tmp97_ = self->priv->file_age_spinbutton;
	_tmp98_ = gtk_spin_button_get_value (_tmp97_);
	_tmp99_ = _tmp98_;
	security_privacy_house_keeping_panel_update_days (self, (guint) _tmp99_);
	_tmp100_ = self->priv->file_age_spinbutton;
	g_signal_connect_data (_tmp100_, "value-changed", (GCallback) __security_privacy_house_keeping_panel___lambda17__gtk_spin_button_value_changed, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
	_tmp101_ = view_trash_button;
	g_signal_connect_object (_tmp101_, "clicked", (GCallback) __security_privacy_house_keeping_panel___lambda18__gtk_button_clicked, self, 0);
	security_privacy_house_keeping_panel_update_status (self);
	_g_object_unref0 (housekeeping_settings);
	_g_object_unref0 (view_trash_button);
	_g_object_unref0 (trash_files_grid);
	_g_object_unref0 (screenshot_files_grid);
	_g_object_unref0 (download_files_grid);
	_g_object_unref0 (temp_files_grid);
	_g_object_unref0 (switch_header_label);
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return obj;
}

static void
security_privacy_house_keeping_panel_class_init (SecurityPrivacyHouseKeepingPanelClass * klass,
                                                 gpointer klass_data)
{
	security_privacy_house_keeping_panel_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SecurityPrivacyHouseKeepingPanel_private_offset);
	G_OBJECT_CLASS (klass)->constructor = security_privacy_house_keeping_panel_constructor;
	G_OBJECT_CLASS (klass)->finalize = security_privacy_house_keeping_panel_finalize;
}

static void
security_privacy_house_keeping_panel_instance_init (SecurityPrivacyHouseKeepingPanel * self,
                                                    gpointer klass)
{
	self->priv = security_privacy_house_keeping_panel_get_instance_private (self);
}

static void
security_privacy_house_keeping_panel_finalize (GObject * obj)
{
	SecurityPrivacyHouseKeepingPanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SECURITY_PRIVACY_TYPE_HOUSE_KEEPING_PANEL, SecurityPrivacyHouseKeepingPanel);
	_g_object_unref0 (self->priv->spin_header_label);
	_g_object_unref0 (self->priv->file_age_label);
	_g_object_unref0 (self->priv->file_age_spinbutton);
	_g_object_unref0 (self->priv->download_files_check);
	_g_object_unref0 (self->priv->screenshot_files_check);
	_g_object_unref0 (self->priv->temp_files_switch);
	_g_object_unref0 (self->priv->trash_files_switch);
	G_OBJECT_CLASS (security_privacy_house_keeping_panel_parent_class)->finalize (obj);
}

static GType
security_privacy_house_keeping_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SecurityPrivacyHouseKeepingPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) security_privacy_house_keeping_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SecurityPrivacyHouseKeepingPanel), 0, (GInstanceInitFunc) security_privacy_house_keeping_panel_instance_init, NULL };
	GType security_privacy_house_keeping_panel_type_id;
	security_privacy_house_keeping_panel_type_id = g_type_register_static (GRANITE_TYPE_SIMPLE_SETTINGS_PAGE, "SecurityPrivacyHouseKeepingPanel", &g_define_type_info, 0);
	SecurityPrivacyHouseKeepingPanel_private_offset = g_type_add_instance_private (security_privacy_house_keeping_panel_type_id, sizeof (SecurityPrivacyHouseKeepingPanelPrivate));
	return security_privacy_house_keeping_panel_type_id;
}

GType
security_privacy_house_keeping_panel_get_type (void)
{
	static volatile gsize security_privacy_house_keeping_panel_type_id__once = 0;
	if (g_once_init_enter (&security_privacy_house_keeping_panel_type_id__once)) {
		GType security_privacy_house_keeping_panel_type_id;
		security_privacy_house_keeping_panel_type_id = security_privacy_house_keeping_panel_get_type_once ();
		g_once_init_leave (&security_privacy_house_keeping_panel_type_id__once, security_privacy_house_keeping_panel_type_id);
	}
	return security_privacy_house_keeping_panel_type_id__once;
}

