/* IncludeTreeView.c generated by valac 0.56.8, the Vala compiler
 * generated from IncludeTreeView.vala, do not modify */

/*-
* Copyright (c) 2014-2017 elementary LLC. (http://launchpad.net/switchboard-plug-security-privacy)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Corentin Noël <corentin@elementaryos.org>
*/

#include "security-privacy.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <zeitgeist-datamodel.h>

enum  {
	INCLUDE_TREE_VIEW_0_PROPERTY,
	INCLUDE_TREE_VIEW_NUM_PROPERTIES
};
static GParamSpec* include_tree_view_properties[INCLUDE_TREE_VIEW_NUM_PROPERTIES];
typedef enum  {
	INCLUDE_TREE_VIEW_COLUMNS_ACTIVE,
	INCLUDE_TREE_VIEW_COLUMNS_NAME,
	INCLUDE_TREE_VIEW_COLUMNS_ICON,
	INCLUDE_TREE_VIEW_COLUMNS_FILE_TYPE,
	INCLUDE_TREE_VIEW_COLUMNS_N_COLUMNS
} IncludeTreeViewColumns;

#define INCLUDE_TREE_VIEW_TYPE_COLUMNS (include_tree_view_columns_get_type ())
#define _security_privacy_file_type_blacklist_unref0(var) ((var == NULL) ? NULL : (var = (security_privacy_file_type_blacklist_unref (var), NULL)))
typedef struct _Block11Data Block11Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _IncludeTreeViewPrivate {
	SecurityPrivacyFileTypeBlacklist* filetype_blacklist;
};

struct _Block11Data {
	int _ref_count_;
	IncludeTreeView* self;
	GtkListStore* list_store;
};

static gint IncludeTreeView_private_offset;
static gpointer include_tree_view_parent_class = NULL;

static GType include_tree_view_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void include_tree_view_set_inclue_iter_to_liststore (IncludeTreeView* self,
                                                     GtkListStore* list_store,
                                                     const gchar* name,
                                                     const gchar* icon,
                                                     const gchar* file_type);
static GObject * include_tree_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void _include_tree_view___lambda22_ (Block11Data* _data11_,
                                     GtkTreePath* path,
                                     GtkTreeViewColumn* column);
static void __include_tree_view___lambda22__gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                  GtkTreePath* path,
                                                                  GtkTreeViewColumn* column,
                                                                  gpointer self);
static void include_tree_view_finalize (GObject * obj);
static GType include_tree_view_get_type_once (void);

static inline gpointer
include_tree_view_get_instance_private (IncludeTreeView* self)
{
	return G_STRUCT_MEMBER_P (self, IncludeTreeView_private_offset);
}

static GType
include_tree_view_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{INCLUDE_TREE_VIEW_COLUMNS_ACTIVE, "INCLUDE_TREE_VIEW_COLUMNS_ACTIVE", "active"}, {INCLUDE_TREE_VIEW_COLUMNS_NAME, "INCLUDE_TREE_VIEW_COLUMNS_NAME", "name"}, {INCLUDE_TREE_VIEW_COLUMNS_ICON, "INCLUDE_TREE_VIEW_COLUMNS_ICON", "icon"}, {INCLUDE_TREE_VIEW_COLUMNS_FILE_TYPE, "INCLUDE_TREE_VIEW_COLUMNS_FILE_TYPE", "file-type"}, {INCLUDE_TREE_VIEW_COLUMNS_N_COLUMNS, "INCLUDE_TREE_VIEW_COLUMNS_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
	GType include_tree_view_columns_type_id;
	include_tree_view_columns_type_id = g_enum_register_static ("IncludeTreeViewColumns", values);
	return include_tree_view_columns_type_id;
}

static GType
include_tree_view_columns_get_type (void)
{
	static volatile gsize include_tree_view_columns_type_id__once = 0;
	if (g_once_init_enter (&include_tree_view_columns_type_id__once)) {
		GType include_tree_view_columns_type_id;
		include_tree_view_columns_type_id = include_tree_view_columns_get_type_once ();
		g_once_init_leave (&include_tree_view_columns_type_id__once, include_tree_view_columns_type_id);
	}
	return include_tree_view_columns_type_id__once;
}

IncludeTreeView*
include_tree_view_construct (GType object_type)
{
	IncludeTreeView * self = NULL;
	self = (IncludeTreeView*) g_object_new (object_type, "row-spacing", 6, NULL);
	return self;
}

IncludeTreeView*
include_tree_view_new (void)
{
	return include_tree_view_construct (TYPE_INCLUDE_TREE_VIEW);
}

static void
include_tree_view_set_inclue_iter_to_liststore (IncludeTreeView* self,
                                                GtkListStore* list_store,
                                                const gchar* name,
                                                const gchar* icon,
                                                const gchar* file_type)
{
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean active = FALSE;
	SecurityPrivacyFileTypeBlacklist* _tmp1_;
	GeeHashSet* _tmp2_;
	GeeHashSet* _tmp3_;
	GtkTreeIter _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (list_store != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (icon != NULL);
	g_return_if_fail (file_type != NULL);
	gtk_list_store_append (list_store, &_tmp0_);
	iter = _tmp0_;
	_tmp1_ = self->priv->filetype_blacklist;
	_tmp2_ = security_privacy_file_type_blacklist_get_all_filetypes (_tmp1_);
	_tmp3_ = _tmp2_;
	active = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp3_, file_type) == FALSE;
	_tmp4_ = iter;
	gtk_list_store_set (list_store, &_tmp4_, INCLUDE_TREE_VIEW_COLUMNS_ACTIVE, active, INCLUDE_TREE_VIEW_COLUMNS_NAME, name, INCLUDE_TREE_VIEW_COLUMNS_ICON, icon, INCLUDE_TREE_VIEW_COLUMNS_FILE_TYPE, file_type, -1);
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
	g_atomic_int_inc (&_data11_->_ref_count_);
	return _data11_;
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
		IncludeTreeView* self;
		self = _data11_->self;
		_g_object_unref0 (_data11_->list_store);
		_g_object_unref0 (self);
		g_slice_free (Block11Data, _data11_);
	}
}

static void
_include_tree_view___lambda22_ (Block11Data* _data11_,
                                GtkTreePath* path,
                                GtkTreeViewColumn* column)
{
	IncludeTreeView* self;
	GValue active = {0};
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GValue _tmp4_ = {0};
	gboolean is_active = FALSE;
	GtkListStore* _tmp5_;
	GtkTreeIter _tmp6_;
	GValue name = {0};
	GtkListStore* _tmp7_;
	GtkTreeIter _tmp8_;
	GValue _tmp9_ = {0};
	self = _data11_->self;
	g_return_if_fail (path != NULL);
	g_return_if_fail (column != NULL);
	_tmp0_ = _data11_->list_store;
	gtk_tree_model_get_iter ((GtkTreeModel*) _tmp0_, &_tmp1_, path);
	iter = _tmp1_;
	_tmp2_ = _data11_->list_store;
	_tmp3_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp2_, &_tmp3_, (gint) INCLUDE_TREE_VIEW_COLUMNS_ACTIVE, &_tmp4_);
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
	active = _tmp4_;
	is_active = !g_value_get_boolean (&active);
	_tmp5_ = _data11_->list_store;
	_tmp6_ = iter;
	gtk_list_store_set (_tmp5_, &_tmp6_, INCLUDE_TREE_VIEW_COLUMNS_ACTIVE, is_active, -1);
	_tmp7_ = _data11_->list_store;
	_tmp8_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp7_, &_tmp8_, (gint) INCLUDE_TREE_VIEW_COLUMNS_FILE_TYPE, &_tmp9_);
	G_IS_VALUE (&name) ? (g_value_unset (&name), NULL) : NULL;
	name = _tmp9_;
	if (is_active == TRUE) {
		SecurityPrivacyFileTypeBlacklist* _tmp10_;
		const gchar* _tmp11_;
		_tmp10_ = self->priv->filetype_blacklist;
		_tmp11_ = g_value_get_string (&name);
		security_privacy_file_type_blacklist_unblock (_tmp10_, _tmp11_);
	} else {
		SecurityPrivacyFileTypeBlacklist* _tmp12_;
		const gchar* _tmp13_;
		_tmp12_ = self->priv->filetype_blacklist;
		_tmp13_ = g_value_get_string (&name);
		security_privacy_file_type_blacklist_block (_tmp12_, _tmp13_);
	}
	G_IS_VALUE (&name) ? (g_value_unset (&name), NULL) : NULL;
	G_IS_VALUE (&active) ? (g_value_unset (&active), NULL) : NULL;
}

static void
__include_tree_view___lambda22__gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                             GtkTreePath* path,
                                                             GtkTreeViewColumn* column,
                                                             gpointer self)
{
	_include_tree_view___lambda22_ (self, path, column);
}

static GObject *
include_tree_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	IncludeTreeView * self;
	Block11Data* _data11_;
	SecurityPrivacyBlacklist* _tmp0_;
	SecurityPrivacyBlacklist* _tmp1_;
	SecurityPrivacyFileTypeBlacklist* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeView* view = NULL;
	GtkListStore* _tmp4_;
	GtkTreeView* _tmp5_;
	GtkTreeView* _tmp6_;
	GtkTreeView* _tmp7_;
	GtkTreeView* _tmp8_;
	GtkCellRendererToggle* celltoggle = NULL;
	GtkCellRendererToggle* _tmp9_;
	GtkTreeView* _tmp10_;
	GtkCellRendererText* cell = NULL;
	GtkCellRendererText* _tmp11_;
	GtkCellRendererPixbuf* cellpixbuf = NULL;
	GtkCellRendererPixbuf* _tmp12_;
	GtkCellRendererPixbuf* _tmp13_;
	GtkTreeView* _tmp14_;
	GtkCellRendererToggle* _tmp15_;
	GtkTreeView* _tmp16_;
	GtkCellRendererPixbuf* _tmp17_;
	GtkTreeView* _tmp18_;
	GtkCellRendererText* _tmp19_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp20_;
	GtkScrolledWindow* _tmp21_;
	GtkScrolledWindow* _tmp22_;
	GtkScrolledWindow* _tmp23_;
	GtkTreeView* _tmp24_;
	GtkLabel* record_label = NULL;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkScrolledWindow* _tmp28_;
	GtkListStore* _tmp29_;
	GtkListStore* _tmp30_;
	GtkListStore* _tmp31_;
	GtkListStore* _tmp32_;
	GtkListStore* _tmp33_;
	GtkListStore* _tmp34_;
	GtkListStore* _tmp35_;
	parent_class = G_OBJECT_CLASS (include_tree_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INCLUDE_TREE_VIEW, IncludeTreeView);
	_data11_ = g_slice_new0 (Block11Data);
	_data11_->_ref_count_ = 1;
	_data11_->self = g_object_ref (self);
	_tmp0_ = security_privacy_track_panel_get_blacklist ();
	_tmp1_ = _tmp0_;
	_tmp2_ = security_privacy_file_type_blacklist_new (_tmp1_);
	_security_privacy_file_type_blacklist_unref0 (self->priv->filetype_blacklist);
	self->priv->filetype_blacklist = _tmp2_;
	_tmp3_ = gtk_list_store_new ((gint) INCLUDE_TREE_VIEW_COLUMNS_N_COLUMNS, G_TYPE_BOOLEAN, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, -1);
	_data11_->list_store = _tmp3_;
	_tmp4_ = _data11_->list_store;
	_tmp5_ = (GtkTreeView*) gtk_tree_view_new_with_model ((GtkTreeModel*) _tmp4_);
	g_object_ref_sink (_tmp5_);
	view = _tmp5_;
	_tmp6_ = view;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp6_, TRUE);
	_tmp7_ = view;
	gtk_tree_view_set_headers_visible (_tmp7_, FALSE);
	_tmp8_ = view;
	gtk_tree_view_set_activate_on_single_click (_tmp8_, TRUE);
	_tmp9_ = (GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ();
	g_object_ref_sink (_tmp9_);
	celltoggle = _tmp9_;
	_tmp10_ = view;
	g_signal_connect_data (_tmp10_, "row-activated", (GCallback) __include_tree_view___lambda22__gtk_tree_view_row_activated, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
	_tmp11_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp11_);
	cell = _tmp11_;
	_tmp12_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
	g_object_ref_sink (_tmp12_);
	cellpixbuf = _tmp12_;
	_tmp13_ = cellpixbuf;
	g_object_set (_tmp13_, "stock-size", (guint) GTK_ICON_SIZE_DND, NULL);
	_tmp14_ = view;
	_tmp15_ = celltoggle;
	gtk_tree_view_insert_column_with_attributes (_tmp14_, -1, "", (GtkCellRenderer*) _tmp15_, "active", INCLUDE_TREE_VIEW_COLUMNS_ACTIVE, NULL);
	_tmp16_ = view;
	_tmp17_ = cellpixbuf;
	gtk_tree_view_insert_column_with_attributes (_tmp16_, -1, "", (GtkCellRenderer*) _tmp17_, "icon-name", INCLUDE_TREE_VIEW_COLUMNS_ICON, NULL);
	_tmp18_ = view;
	_tmp19_ = cell;
	gtk_tree_view_insert_column_with_attributes (_tmp18_, -1, "", (GtkCellRenderer*) _tmp19_, "markup", INCLUDE_TREE_VIEW_COLUMNS_NAME, NULL);
	_tmp20_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp20_);
	scrolled = _tmp20_;
	_tmp21_ = scrolled;
	gtk_scrolled_window_set_shadow_type (_tmp21_, GTK_SHADOW_IN);
	_tmp22_ = scrolled;
	g_object_set ((GtkWidget*) _tmp22_, "expand", TRUE, NULL);
	_tmp23_ = scrolled;
	_tmp24_ = view;
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = (GtkLabel*) gtk_label_new (_ ("Data Sources:"));
	g_object_ref_sink (_tmp25_);
	record_label = _tmp25_;
	_tmp26_ = record_label;
	gtk_label_set_xalign (_tmp26_, (gfloat) 0);
	_tmp27_ = record_label;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp27_, 0, 0, 1, 1);
	_tmp28_ = scrolled;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp28_, 0, 1, 1, 1);
	_tmp29_ = _data11_->list_store;
	include_tree_view_set_inclue_iter_to_liststore (self, _tmp29_, _ ("Chat Logs"), "internet-chat", ZEITGEIST_NMO_IMMESSAGE);
	_tmp30_ = _data11_->list_store;
	include_tree_view_set_inclue_iter_to_liststore (self, _tmp30_, _ ("Documents"), "x-office-document", ZEITGEIST_NFO_DOCUMENT);
	_tmp31_ = _data11_->list_store;
	include_tree_view_set_inclue_iter_to_liststore (self, _tmp31_, _ ("Music"), "audio-x-generic", ZEITGEIST_NFO_AUDIO);
	_tmp32_ = _data11_->list_store;
	include_tree_view_set_inclue_iter_to_liststore (self, _tmp32_, _ ("Pictures"), "image-x-generic", ZEITGEIST_NFO_IMAGE);
	_tmp33_ = _data11_->list_store;
	include_tree_view_set_inclue_iter_to_liststore (self, _tmp33_, _ ("Presentations"), "x-office-presentation", ZEITGEIST_NFO_PRESENTATION);
	_tmp34_ = _data11_->list_store;
	include_tree_view_set_inclue_iter_to_liststore (self, _tmp34_, _ ("Spreadsheets"), "x-office-spreadsheet", ZEITGEIST_NFO_SPREADSHEET);
	_tmp35_ = _data11_->list_store;
	include_tree_view_set_inclue_iter_to_liststore (self, _tmp35_, _ ("Videos"), "video-x-generic", ZEITGEIST_NFO_VIDEO);
	_g_object_unref0 (record_label);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (cellpixbuf);
	_g_object_unref0 (cell);
	_g_object_unref0 (celltoggle);
	_g_object_unref0 (view);
	block11_data_unref (_data11_);
	_data11_ = NULL;
	return obj;
}

static void
include_tree_view_class_init (IncludeTreeViewClass * klass,
                              gpointer klass_data)
{
	include_tree_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &IncludeTreeView_private_offset);
	G_OBJECT_CLASS (klass)->constructor = include_tree_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = include_tree_view_finalize;
}

static void
include_tree_view_instance_init (IncludeTreeView * self,
                                 gpointer klass)
{
	self->priv = include_tree_view_get_instance_private (self);
}

static void
include_tree_view_finalize (GObject * obj)
{
	IncludeTreeView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INCLUDE_TREE_VIEW, IncludeTreeView);
	_security_privacy_file_type_blacklist_unref0 (self->priv->filetype_blacklist);
	G_OBJECT_CLASS (include_tree_view_parent_class)->finalize (obj);
}

static GType
include_tree_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IncludeTreeViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) include_tree_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IncludeTreeView), 0, (GInstanceInitFunc) include_tree_view_instance_init, NULL };
	GType include_tree_view_type_id;
	include_tree_view_type_id = g_type_register_static (gtk_grid_get_type (), "IncludeTreeView", &g_define_type_info, 0);
	IncludeTreeView_private_offset = g_type_add_instance_private (include_tree_view_type_id, sizeof (IncludeTreeViewPrivate));
	return include_tree_view_type_id;
}

GType
include_tree_view_get_type (void)
{
	static volatile gsize include_tree_view_type_id__once = 0;
	if (g_once_init_enter (&include_tree_view_type_id__once)) {
		GType include_tree_view_type_id;
		include_tree_view_type_id = include_tree_view_get_type_once ();
		g_once_init_leave (&include_tree_view_type_id__once, include_tree_view_type_id);
	}
	return include_tree_view_type_id__once;
}

