/* ServiceItem.c generated by valac 0.56.8, the Vala compiler
 * generated from ServiceItem.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2017 elementary LLC. (http://launchpad.net/switchboard-plug-security-privacy)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "security-privacy.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

enum  {
	SERVICE_ITEM_0_PROPERTY,
	SERVICE_ITEM_STATUS_PROPERTY,
	SERVICE_ITEM_ICON_NAME_PROPERTY,
	SERVICE_ITEM_LABEL_PROPERTY,
	SERVICE_ITEM_TITLE_PROPERTY,
	SERVICE_ITEM_NUM_PROPERTIES
};
static GParamSpec* service_item_properties[SERVICE_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ServiceItemPrivate {
	GtkImage* status_icon;
	GtkLabel* status_label;
	gchar* _icon_name;
	gchar* _label;
	gchar* _title;
};

static gint ServiceItem_private_offset;
static gpointer service_item_parent_class = NULL;

static GObject * service_item_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void service_item_finalize (GObject * obj);
static GType service_item_get_type_once (void);
static void _vala_service_item_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_service_item_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
service_item_get_instance_private (ServiceItem* self)
{
	return G_STRUCT_MEMBER_P (self, ServiceItem_private_offset);
}

static GType
service_item_status_get_type_once (void)
{
	static const GEnumValue values[] = {{SERVICE_ITEM_STATUS_ENABLED, "SERVICE_ITEM_STATUS_ENABLED", "enabled"}, {SERVICE_ITEM_STATUS_DISABLED, "SERVICE_ITEM_STATUS_DISABLED", "disabled"}, {SERVICE_ITEM_STATUS_PARTIAL, "SERVICE_ITEM_STATUS_PARTIAL", "partial"}, {0, NULL, NULL}};
	GType service_item_status_type_id;
	service_item_status_type_id = g_enum_register_static ("ServiceItemStatus", values);
	return service_item_status_type_id;
}

GType
service_item_status_get_type (void)
{
	static volatile gsize service_item_status_type_id__once = 0;
	if (g_once_init_enter (&service_item_status_type_id__once)) {
		GType service_item_status_type_id;
		service_item_status_type_id = service_item_status_get_type_once ();
		g_once_init_leave (&service_item_status_type_id__once, service_item_status_type_id);
	}
	return service_item_status_type_id__once;
}

ServiceItem*
service_item_construct (GType object_type,
                        const gchar* icon_name,
                        const gchar* title,
                        const gchar* label)
{
	ServiceItem * self = NULL;
	g_return_val_if_fail (icon_name != NULL, NULL);
	g_return_val_if_fail (title != NULL, NULL);
	g_return_val_if_fail (label != NULL, NULL);
	self = (ServiceItem*) g_object_new (object_type, "icon-name", icon_name, "label", label, "title", title, NULL);
	return self;
}

ServiceItem*
service_item_new (const gchar* icon_name,
                  const gchar* title,
                  const gchar* label)
{
	return service_item_construct (TYPE_SERVICE_ITEM, icon_name, title, label);
}

void
service_item_set_status (ServiceItem* self,
                         ServiceItemStatus value)
{
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	g_return_if_fail (self != NULL);
	switch (value) {
		case SERVICE_ITEM_STATUS_ENABLED:
		{
			GtkImage* _tmp0_;
			GtkLabel* _tmp1_;
			_tmp0_ = self->priv->status_icon;
			g_object_set (_tmp0_, "icon-name", "user-available", NULL);
			_tmp1_ = self->priv->status_label;
			gtk_label_set_label (_tmp1_, _ ("Enabled"));
			break;
		}
		case SERVICE_ITEM_STATUS_DISABLED:
		{
			GtkImage* _tmp2_;
			GtkLabel* _tmp3_;
			_tmp2_ = self->priv->status_icon;
			g_object_set (_tmp2_, "icon-name", "user-offline", NULL);
			_tmp3_ = self->priv->status_label;
			gtk_label_set_label (_tmp3_, _ ("Disabled"));
			break;
		}
		case SERVICE_ITEM_STATUS_PARTIAL:
		{
			GtkImage* _tmp4_;
			GtkLabel* _tmp5_;
			_tmp4_ = self->priv->status_icon;
			g_object_set (_tmp4_, "icon-name", "user-away", NULL);
			_tmp5_ = self->priv->status_label;
			gtk_label_set_label (_tmp5_, _ ("Partially Enabled"));
			break;
		}
		default:
		break;
	}
	_tmp6_ = self->priv->status_label;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp6_, FALSE);
	_tmp7_ = self->priv->status_label;
	gtk_widget_show ((GtkWidget*) _tmp7_);
	_tmp8_ = self->priv->status_label;
	_tmp9_ = self->priv->status_label;
	_tmp10_ = gtk_label_get_label (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat ("<span font_size='small'>", _tmp11_, NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_tmp13_, "</span>", NULL);
	_tmp15_ = _tmp14_;
	gtk_label_set_label (_tmp8_, _tmp15_);
	_g_free0 (_tmp15_);
	_g_free0 (_tmp13_);
	g_object_notify_by_pspec ((GObject *) self, service_item_properties[SERVICE_ITEM_STATUS_PROPERTY]);
}

const gchar*
service_item_get_icon_name (ServiceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}

static void
service_item_set_icon_name (ServiceItem* self,
                            const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = service_item_get_icon_name (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, service_item_properties[SERVICE_ITEM_ICON_NAME_PROPERTY]);
	}
}

const gchar*
service_item_get_label (ServiceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_label;
	result = _tmp0_;
	return result;
}

static void
service_item_set_label (ServiceItem* self,
                        const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = service_item_get_label (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_label);
		self->priv->_label = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, service_item_properties[SERVICE_ITEM_LABEL_PROPERTY]);
	}
}

const gchar*
service_item_get_title (ServiceItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_title;
	result = _tmp0_;
	return result;
}

static void
service_item_set_title (ServiceItem* self,
                        const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = service_item_get_title (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_title);
		self->priv->_title = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, service_item_properties[SERVICE_ITEM_TITLE_PROPERTY]);
	}
}

static GObject *
service_item_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ServiceItem * self;
	GtkImage* icon = NULL;
	const gchar* _tmp0_;
	GtkImage* _tmp1_;
	GtkLabel* title_label = NULL;
	const gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp16_;
	GtkOverlay* _tmp17_;
	GtkOverlay* _tmp18_;
	GtkImage* _tmp19_;
	GtkOverlay* _tmp20_;
	GtkImage* _tmp21_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	GtkOverlay* _tmp26_;
	GtkGrid* _tmp27_;
	GtkLabel* _tmp28_;
	GtkGrid* _tmp29_;
	GtkLabel* _tmp30_;
	GtkGrid* _tmp31_;
	parent_class = G_OBJECT_CLASS (service_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERVICE_ITEM, ServiceItem);
	_tmp0_ = self->priv->_icon_name;
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DND);
	g_object_ref_sink (_tmp1_);
	icon = _tmp1_;
	_tmp2_ = self->priv->_label;
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
	g_object_ref_sink (_tmp3_);
	title_label = _tmp3_;
	_tmp4_ = title_label;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_add_class (_tmp5_, "h3");
	_tmp6_ = title_label;
	gtk_label_set_ellipsize (_tmp6_, PANGO_ELLIPSIZE_END);
	_tmp7_ = title_label;
	gtk_label_set_xalign (_tmp7_, (gfloat) 0);
	_tmp8_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp8_);
	_g_object_unref0 (self->priv->status_icon);
	self->priv->status_icon = _tmp8_;
	_tmp9_ = self->priv->status_icon;
	gtk_widget_set_halign ((GtkWidget*) _tmp9_, GTK_ALIGN_END);
	_tmp10_ = self->priv->status_icon;
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_END);
	_tmp11_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->status_label);
	self->priv->status_label = _tmp11_;
	_tmp12_ = self->priv->status_label;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp12_, TRUE);
	_tmp13_ = self->priv->status_label;
	gtk_label_set_use_markup (_tmp13_, TRUE);
	_tmp14_ = self->priv->status_label;
	gtk_label_set_ellipsize (_tmp14_, PANGO_ELLIPSIZE_END);
	_tmp15_ = self->priv->status_label;
	gtk_label_set_xalign (_tmp15_, (gfloat) 0);
	_tmp16_ = (GtkOverlay*) gtk_overlay_new ();
	g_object_ref_sink (_tmp16_);
	overlay = _tmp16_;
	_tmp17_ = overlay;
	g_object_set ((GtkWidget*) _tmp17_, "width-request", 38, NULL);
	_tmp18_ = overlay;
	_tmp19_ = icon;
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = overlay;
	_tmp21_ = self->priv->status_icon;
	gtk_overlay_add_overlay (_tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp22_);
	grid = _tmp22_;
	_tmp23_ = grid;
	g_object_set ((GtkWidget*) _tmp23_, "margin", 6, NULL);
	_tmp24_ = grid;
	gtk_grid_set_column_spacing (_tmp24_, 6);
	_tmp25_ = grid;
	_tmp26_ = overlay;
	gtk_grid_attach (_tmp25_, (GtkWidget*) _tmp26_, 0, 0, 1, 2);
	_tmp27_ = grid;
	_tmp28_ = title_label;
	gtk_grid_attach (_tmp27_, (GtkWidget*) _tmp28_, 1, 0, 1, 1);
	_tmp29_ = grid;
	_tmp30_ = self->priv->status_label;
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 1, 1, 1, 1);
	_tmp31_ = grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp31_);
	_g_object_unref0 (grid);
	_g_object_unref0 (overlay);
	_g_object_unref0 (title_label);
	_g_object_unref0 (icon);
	return obj;
}

static void
service_item_class_init (ServiceItemClass * klass,
                         gpointer klass_data)
{
	service_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ServiceItem_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_service_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_service_item_set_property;
	G_OBJECT_CLASS (klass)->constructor = service_item_constructor;
	G_OBJECT_CLASS (klass)->finalize = service_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICE_ITEM_STATUS_PROPERTY, service_item_properties[SERVICE_ITEM_STATUS_PROPERTY] = g_param_spec_enum ("status", "status", "status", SERVICE_ITEM_TYPE_STATUS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICE_ITEM_ICON_NAME_PROPERTY, service_item_properties[SERVICE_ITEM_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICE_ITEM_LABEL_PROPERTY, service_item_properties[SERVICE_ITEM_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICE_ITEM_TITLE_PROPERTY, service_item_properties[SERVICE_ITEM_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
service_item_instance_init (ServiceItem * self,
                            gpointer klass)
{
	self->priv = service_item_get_instance_private (self);
}

static void
service_item_finalize (GObject * obj)
{
	ServiceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SERVICE_ITEM, ServiceItem);
	_g_object_unref0 (self->priv->status_icon);
	_g_object_unref0 (self->priv->status_label);
	_g_free0 (self->priv->_icon_name);
	_g_free0 (self->priv->_label);
	_g_free0 (self->priv->_title);
	G_OBJECT_CLASS (service_item_parent_class)->finalize (obj);
}

static GType
service_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServiceItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) service_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServiceItem), 0, (GInstanceInitFunc) service_item_instance_init, NULL };
	GType service_item_type_id;
	service_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "ServiceItem", &g_define_type_info, 0);
	ServiceItem_private_offset = g_type_add_instance_private (service_item_type_id, sizeof (ServiceItemPrivate));
	return service_item_type_id;
}

GType
service_item_get_type (void)
{
	static volatile gsize service_item_type_id__once = 0;
	if (g_once_init_enter (&service_item_type_id__once)) {
		GType service_item_type_id;
		service_item_type_id = service_item_get_type_once ();
		g_once_init_leave (&service_item_type_id__once, service_item_type_id);
	}
	return service_item_type_id__once;
}

static void
_vala_service_item_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	ServiceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERVICE_ITEM, ServiceItem);
	switch (property_id) {
		case SERVICE_ITEM_ICON_NAME_PROPERTY:
		g_value_set_string (value, service_item_get_icon_name (self));
		break;
		case SERVICE_ITEM_LABEL_PROPERTY:
		g_value_set_string (value, service_item_get_label (self));
		break;
		case SERVICE_ITEM_TITLE_PROPERTY:
		g_value_set_string (value, service_item_get_title (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_service_item_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	ServiceItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SERVICE_ITEM, ServiceItem);
	switch (property_id) {
		case SERVICE_ITEM_STATUS_PROPERTY:
		service_item_set_status (self, g_value_get_enum (value));
		break;
		case SERVICE_ITEM_ICON_NAME_PROPERTY:
		service_item_set_icon_name (self, g_value_get_string (value));
		break;
		case SERVICE_ITEM_LABEL_PROPERTY:
		service_item_set_label (self, g_value_get_string (value));
		break;
		case SERVICE_ITEM_TITLE_PROPERTY:
		service_item_set_title (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

